#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 575
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 164
#define ALIAS_COUNT 1
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 2
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 6

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_include = 2,
  sym_preprocessor_directive = 3,
  anon_sym_LBRACE = 4,
  anon_sym_RBRACE = 5,
  anon_sym_class = 6,
  anon_sym_LT = 7,
  anon_sym_COMMA = 8,
  anon_sym_GT = 9,
  anon_sym_EQ = 10,
  anon_sym_COLON = 11,
  anon_sym_SEMI = 12,
  anon_sym_field = 13,
  anon_sym_code = 14,
  anon_sym_let = 15,
  anon_sym_defvar = 16,
  anon_sym_def = 17,
  anon_sym_in = 18,
  anon_sym_multiclass = 19,
  anon_sym_defm = 20,
  anon_sym_defset = 21,
  anon_sym_foreach = 22,
  anon_sym_if = 23,
  anon_sym_then = 24,
  anon_sym_else = 25,
  anon_sym_assert = 26,
  anon_sym_bit = 27,
  anon_sym_int = 28,
  anon_sym_string = 29,
  anon_sym_dag = 30,
  anon_sym_bits = 31,
  anon_sym_list = 32,
  anon_sym_POUND = 33,
  anon_sym_LBRACK = 34,
  anon_sym_RBRACK = 35,
  anon_sym_DOT = 36,
  anon_sym_DOT_DOT_DOT = 37,
  anon_sym_DASH = 38,
  anon_sym_QMARK = 39,
  anon_sym_LPAREN = 40,
  anon_sym_RPAREN = 41,
  anon_sym_BANG = 42,
  anon_sym_add = 43,
  anon_sym_and = 44,
  anon_sym_cast = 45,
  anon_sym_con = 46,
  anon_sym_div = 47,
  anon_sym_empty = 48,
  anon_sym_eq = 49,
  anon_sym_exists = 50,
  anon_sym_filter = 51,
  anon_sym_find = 52,
  anon_sym_foldl = 53,
  anon_sym_ge = 54,
  anon_sym_getop = 55,
  anon_sym_getdagop = 56,
  anon_sym_gt = 57,
  anon_sym_head = 58,
  anon_sym_interleave = 59,
  anon_sym_isa = 60,
  anon_sym_le = 61,
  anon_sym_listconcat = 62,
  anon_sym_listremove = 63,
  anon_sym_listsplat = 64,
  anon_sym_logtwo = 65,
  anon_sym_lt = 66,
  anon_sym_mul = 67,
  anon_sym_ne = 68,
  anon_sym_not = 69,
  anon_sym_or = 70,
  anon_sym_setop = 71,
  anon_sym_setdagop = 72,
  anon_sym_shl = 73,
  anon_sym_size = 74,
  anon_sym_sra = 75,
  anon_sym_srl = 76,
  anon_sym_strconcat = 77,
  anon_sym_sub = 78,
  anon_sym_subst = 79,
  anon_sym_substr = 80,
  anon_sym_tail = 81,
  anon_sym_tolower = 82,
  anon_sym_toupper = 83,
  anon_sym_xor = 84,
  anon_sym_cond = 85,
  sym_integer = 86,
  anon_sym_DQUOTE = 87,
  sym_string_content = 88,
  aux_sym__escape_sequence_token1 = 89,
  sym_escape_sequence = 90,
  sym_code = 91,
  anon_sym_true = 92,
  anon_sym_false = 93,
  sym_var = 94,
  sym_comment = 95,
  sym_multiline_comment = 96,
  sym_tablegen_file = 97,
  sym_include_directive = 98,
  sym_statement = 99,
  sym_block = 100,
  sym_class = 101,
  sym_template_args = 102,
  sym_template_arg = 103,
  sym_record_body = 104,
  sym_parent_class_list = 105,
  sym_body = 106,
  sym_body_item = 107,
  sym_instruction = 108,
  sym_let_instruction = 109,
  sym_def_var = 110,
  sym_def = 111,
  sym_let = 112,
  sym_let_list = 113,
  sym_let_item = 114,
  sym_multiclass = 115,
  sym_multiclass_body = 116,
  sym_multiclass_statement = 117,
  sym_defm = 118,
  sym_defset = 119,
  sym_defvar = 120,
  sym_foreach = 121,
  sym_foreach_iterator = 122,
  sym_if = 123,
  sym_assert = 124,
  sym_type = 125,
  sym_primitive_type = 126,
  sym_bits_type = 127,
  sym_list_type = 128,
  sym_value = 129,
  sym_paste_value = 130,
  sym_value_suffix = 131,
  sym_value_list = 132,
  sym_range_list = 133,
  sym_range_piece = 134,
  sym_simple_value = 135,
  sym_sequence = 136,
  sym_list_initializer = 137,
  sym_dag_initializer = 138,
  sym_dag_arg_list = 139,
  sym_dag_arg = 140,
  sym_anonymous_record = 141,
  sym_concatenated_string = 142,
  sym_operator = 143,
  sym_cond_clause = 144,
  sym_bang_operator = 145,
  sym_cond_operator = 146,
  sym_string = 147,
  sym__escape_sequence = 148,
  sym_boolean = 149,
  aux_sym_tablegen_file_repeat1 = 150,
  aux_sym_block_repeat1 = 151,
  aux_sym_template_args_repeat1 = 152,
  aux_sym_parent_class_list_repeat1 = 153,
  aux_sym_parent_class_list_repeat2 = 154,
  aux_sym_body_repeat1 = 155,
  aux_sym_let_list_repeat1 = 156,
  aux_sym_multiclass_body_repeat1 = 157,
  aux_sym_value_repeat1 = 158,
  aux_sym_range_list_repeat1 = 159,
  aux_sym_dag_arg_list_repeat1 = 160,
  aux_sym_concatenated_string_repeat1 = 161,
  aux_sym_operator_repeat1 = 162,
  aux_sym_string_repeat1 = 163,
  alias_sym_class_identifier = 164,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_include] = "include",
  [sym_preprocessor_directive] = "preprocessor_directive",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_class] = "class",
  [anon_sym_LT] = "<",
  [anon_sym_COMMA] = ",",
  [anon_sym_GT] = ">",
  [anon_sym_EQ] = "=",
  [anon_sym_COLON] = ":",
  [anon_sym_SEMI] = ";",
  [anon_sym_field] = "field",
  [anon_sym_code] = "code",
  [anon_sym_let] = "let",
  [anon_sym_defvar] = "defvar",
  [anon_sym_def] = "def",
  [anon_sym_in] = "in",
  [anon_sym_multiclass] = "multiclass",
  [anon_sym_defm] = "defm",
  [anon_sym_defset] = "defset",
  [anon_sym_foreach] = "foreach",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_else] = "else",
  [anon_sym_assert] = "assert",
  [anon_sym_bit] = "bit",
  [anon_sym_int] = "int",
  [anon_sym_string] = "string",
  [anon_sym_dag] = "dag",
  [anon_sym_bits] = "bits",
  [anon_sym_list] = "list",
  [anon_sym_POUND] = "#",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_DASH] = "-",
  [anon_sym_QMARK] = "uninitialized_value",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_BANG] = "!",
  [anon_sym_add] = "add",
  [anon_sym_and] = "and",
  [anon_sym_cast] = "cast",
  [anon_sym_con] = "con",
  [anon_sym_div] = "div",
  [anon_sym_empty] = "empty",
  [anon_sym_eq] = "eq",
  [anon_sym_exists] = "exists",
  [anon_sym_filter] = "filter",
  [anon_sym_find] = "find",
  [anon_sym_foldl] = "foldl",
  [anon_sym_ge] = "ge",
  [anon_sym_getop] = "getop",
  [anon_sym_getdagop] = "getdagop",
  [anon_sym_gt] = "gt",
  [anon_sym_head] = "head",
  [anon_sym_interleave] = "interleave",
  [anon_sym_isa] = "isa",
  [anon_sym_le] = "le",
  [anon_sym_listconcat] = "listconcat",
  [anon_sym_listremove] = "listremove",
  [anon_sym_listsplat] = "listsplat",
  [anon_sym_logtwo] = "logtwo",
  [anon_sym_lt] = "lt",
  [anon_sym_mul] = "mul",
  [anon_sym_ne] = "ne",
  [anon_sym_not] = "not",
  [anon_sym_or] = "or",
  [anon_sym_setop] = "setop",
  [anon_sym_setdagop] = "setdagop",
  [anon_sym_shl] = "shl",
  [anon_sym_size] = "size",
  [anon_sym_sra] = "sra",
  [anon_sym_srl] = "srl",
  [anon_sym_strconcat] = "strconcat",
  [anon_sym_sub] = "sub",
  [anon_sym_subst] = "subst",
  [anon_sym_substr] = "substr",
  [anon_sym_tail] = "tail",
  [anon_sym_tolower] = "tolower",
  [anon_sym_toupper] = "toupper",
  [anon_sym_xor] = "xor",
  [anon_sym_cond] = "cond",
  [sym_integer] = "integer",
  [anon_sym_DQUOTE] = "\"",
  [sym_string_content] = "string_content",
  [aux_sym__escape_sequence_token1] = "_escape_sequence_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_code] = "code",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_var] = "var",
  [sym_comment] = "comment",
  [sym_multiline_comment] = "multiline_comment",
  [sym_tablegen_file] = "tablegen_file",
  [sym_include_directive] = "include_directive",
  [sym_statement] = "statement",
  [sym_block] = "block",
  [sym_class] = "class",
  [sym_template_args] = "template_args",
  [sym_template_arg] = "template_arg",
  [sym_record_body] = "record_body",
  [sym_parent_class_list] = "parent_class_list",
  [sym_body] = "body",
  [sym_body_item] = "body_item",
  [sym_instruction] = "instruction",
  [sym_let_instruction] = "let_instruction",
  [sym_def_var] = "def_var",
  [sym_def] = "def",
  [sym_let] = "let",
  [sym_let_list] = "let_list",
  [sym_let_item] = "let_item",
  [sym_multiclass] = "multiclass",
  [sym_multiclass_body] = "multiclass_body",
  [sym_multiclass_statement] = "multiclass_statement",
  [sym_defm] = "defm",
  [sym_defset] = "defset",
  [sym_defvar] = "defvar",
  [sym_foreach] = "foreach",
  [sym_foreach_iterator] = "foreach_iterator",
  [sym_if] = "if",
  [sym_assert] = "assert",
  [sym_type] = "type",
  [sym_primitive_type] = "primitive_type",
  [sym_bits_type] = "bits_type",
  [sym_list_type] = "list_type",
  [sym_value] = "value",
  [sym_paste_value] = "paste_value",
  [sym_value_suffix] = "value_suffix",
  [sym_value_list] = "value_list",
  [sym_range_list] = "range_list",
  [sym_range_piece] = "range_piece",
  [sym_simple_value] = "simple_value",
  [sym_sequence] = "sequence",
  [sym_list_initializer] = "list_initializer",
  [sym_dag_initializer] = "dag_initializer",
  [sym_dag_arg_list] = "dag_arg_list",
  [sym_dag_arg] = "dag_arg",
  [sym_anonymous_record] = "anonymous_record",
  [sym_concatenated_string] = "concatenated_string",
  [sym_operator] = "operator",
  [sym_cond_clause] = "cond_clause",
  [sym_bang_operator] = "bang_operator",
  [sym_cond_operator] = "cond_operator",
  [sym_string] = "string",
  [sym__escape_sequence] = "_escape_sequence",
  [sym_boolean] = "boolean",
  [aux_sym_tablegen_file_repeat1] = "tablegen_file_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_template_args_repeat1] = "template_args_repeat1",
  [aux_sym_parent_class_list_repeat1] = "parent_class_list_repeat1",
  [aux_sym_parent_class_list_repeat2] = "parent_class_list_repeat2",
  [aux_sym_body_repeat1] = "body_repeat1",
  [aux_sym_let_list_repeat1] = "let_list_repeat1",
  [aux_sym_multiclass_body_repeat1] = "multiclass_body_repeat1",
  [aux_sym_value_repeat1] = "value_repeat1",
  [aux_sym_range_list_repeat1] = "range_list_repeat1",
  [aux_sym_dag_arg_list_repeat1] = "dag_arg_list_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_operator_repeat1] = "operator_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [alias_sym_class_identifier] = "class_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_include] = anon_sym_include,
  [sym_preprocessor_directive] = sym_preprocessor_directive,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_code] = anon_sym_code,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_defvar] = anon_sym_defvar,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_multiclass] = anon_sym_multiclass,
  [anon_sym_defm] = anon_sym_defm,
  [anon_sym_defset] = anon_sym_defset,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_bit] = anon_sym_bit,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_dag] = anon_sym_dag,
  [anon_sym_bits] = anon_sym_bits,
  [anon_sym_list] = anon_sym_list,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_cast] = anon_sym_cast,
  [anon_sym_con] = anon_sym_con,
  [anon_sym_div] = anon_sym_div,
  [anon_sym_empty] = anon_sym_empty,
  [anon_sym_eq] = anon_sym_eq,
  [anon_sym_exists] = anon_sym_exists,
  [anon_sym_filter] = anon_sym_filter,
  [anon_sym_find] = anon_sym_find,
  [anon_sym_foldl] = anon_sym_foldl,
  [anon_sym_ge] = anon_sym_ge,
  [anon_sym_getop] = anon_sym_getop,
  [anon_sym_getdagop] = anon_sym_getdagop,
  [anon_sym_gt] = anon_sym_gt,
  [anon_sym_head] = anon_sym_head,
  [anon_sym_interleave] = anon_sym_interleave,
  [anon_sym_isa] = anon_sym_isa,
  [anon_sym_le] = anon_sym_le,
  [anon_sym_listconcat] = anon_sym_listconcat,
  [anon_sym_listremove] = anon_sym_listremove,
  [anon_sym_listsplat] = anon_sym_listsplat,
  [anon_sym_logtwo] = anon_sym_logtwo,
  [anon_sym_lt] = anon_sym_lt,
  [anon_sym_mul] = anon_sym_mul,
  [anon_sym_ne] = anon_sym_ne,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_setop] = anon_sym_setop,
  [anon_sym_setdagop] = anon_sym_setdagop,
  [anon_sym_shl] = anon_sym_shl,
  [anon_sym_size] = anon_sym_size,
  [anon_sym_sra] = anon_sym_sra,
  [anon_sym_srl] = anon_sym_srl,
  [anon_sym_strconcat] = anon_sym_strconcat,
  [anon_sym_sub] = anon_sym_sub,
  [anon_sym_subst] = anon_sym_subst,
  [anon_sym_substr] = anon_sym_substr,
  [anon_sym_tail] = anon_sym_tail,
  [anon_sym_tolower] = anon_sym_tolower,
  [anon_sym_toupper] = anon_sym_toupper,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_cond] = anon_sym_cond,
  [sym_integer] = sym_integer,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [sym_string_content] = sym_string_content,
  [aux_sym__escape_sequence_token1] = aux_sym__escape_sequence_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_code] = sym_code,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_var] = sym_var,
  [sym_comment] = sym_comment,
  [sym_multiline_comment] = sym_multiline_comment,
  [sym_tablegen_file] = sym_tablegen_file,
  [sym_include_directive] = sym_include_directive,
  [sym_statement] = sym_statement,
  [sym_block] = sym_block,
  [sym_class] = sym_class,
  [sym_template_args] = sym_template_args,
  [sym_template_arg] = sym_template_arg,
  [sym_record_body] = sym_record_body,
  [sym_parent_class_list] = sym_parent_class_list,
  [sym_body] = sym_body,
  [sym_body_item] = sym_body_item,
  [sym_instruction] = sym_instruction,
  [sym_let_instruction] = sym_let_instruction,
  [sym_def_var] = sym_def_var,
  [sym_def] = sym_def,
  [sym_let] = sym_let,
  [sym_let_list] = sym_let_list,
  [sym_let_item] = sym_let_item,
  [sym_multiclass] = sym_multiclass,
  [sym_multiclass_body] = sym_multiclass_body,
  [sym_multiclass_statement] = sym_multiclass_statement,
  [sym_defm] = sym_defm,
  [sym_defset] = sym_defset,
  [sym_defvar] = sym_defvar,
  [sym_foreach] = sym_foreach,
  [sym_foreach_iterator] = sym_foreach_iterator,
  [sym_if] = sym_if,
  [sym_assert] = sym_assert,
  [sym_type] = sym_type,
  [sym_primitive_type] = sym_primitive_type,
  [sym_bits_type] = sym_bits_type,
  [sym_list_type] = sym_list_type,
  [sym_value] = sym_value,
  [sym_paste_value] = sym_paste_value,
  [sym_value_suffix] = sym_value_suffix,
  [sym_value_list] = sym_value_list,
  [sym_range_list] = sym_range_list,
  [sym_range_piece] = sym_range_piece,
  [sym_simple_value] = sym_simple_value,
  [sym_sequence] = sym_sequence,
  [sym_list_initializer] = sym_list_initializer,
  [sym_dag_initializer] = sym_dag_initializer,
  [sym_dag_arg_list] = sym_dag_arg_list,
  [sym_dag_arg] = sym_dag_arg,
  [sym_anonymous_record] = sym_anonymous_record,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_operator] = sym_operator,
  [sym_cond_clause] = sym_cond_clause,
  [sym_bang_operator] = sym_bang_operator,
  [sym_cond_operator] = sym_cond_operator,
  [sym_string] = sym_string,
  [sym__escape_sequence] = sym__escape_sequence,
  [sym_boolean] = sym_boolean,
  [aux_sym_tablegen_file_repeat1] = aux_sym_tablegen_file_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_template_args_repeat1] = aux_sym_template_args_repeat1,
  [aux_sym_parent_class_list_repeat1] = aux_sym_parent_class_list_repeat1,
  [aux_sym_parent_class_list_repeat2] = aux_sym_parent_class_list_repeat2,
  [aux_sym_body_repeat1] = aux_sym_body_repeat1,
  [aux_sym_let_list_repeat1] = aux_sym_let_list_repeat1,
  [aux_sym_multiclass_body_repeat1] = aux_sym_multiclass_body_repeat1,
  [aux_sym_value_repeat1] = aux_sym_value_repeat1,
  [aux_sym_range_list_repeat1] = aux_sym_range_list_repeat1,
  [aux_sym_dag_arg_list_repeat1] = aux_sym_dag_arg_list_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_operator_repeat1] = aux_sym_operator_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [alias_sym_class_identifier] = alias_sym_class_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_include] = {
    .visible = true,
    .named = false,
  },
  [sym_preprocessor_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_code] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defvar] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_multiclass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dag] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_list] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_con] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_div] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_empty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exists] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_filter] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_find] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foldl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getdagop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_head] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interleave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isa] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_le] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_listconcat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_listremove] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_listsplat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_logtwo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mul] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ne] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_setop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_setdagop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_size] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sra] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_srl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strconcat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_subst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_substr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tail] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tolower] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_toupper] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cond] = {
    .visible = true,
    .named = false,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_code] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_var] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_multiline_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_tablegen_file] = {
    .visible = true,
    .named = true,
  },
  [sym_include_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_template_args] = {
    .visible = true,
    .named = true,
  },
  [sym_template_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_record_body] = {
    .visible = true,
    .named = true,
  },
  [sym_parent_class_list] = {
    .visible = true,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym_body_item] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction] = {
    .visible = true,
    .named = true,
  },
  [sym_let_instruction] = {
    .visible = true,
    .named = true,
  },
  [sym_def_var] = {
    .visible = true,
    .named = true,
  },
  [sym_def] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym_let_list] = {
    .visible = true,
    .named = true,
  },
  [sym_let_item] = {
    .visible = true,
    .named = true,
  },
  [sym_multiclass] = {
    .visible = true,
    .named = true,
  },
  [sym_multiclass_body] = {
    .visible = true,
    .named = true,
  },
  [sym_multiclass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_defm] = {
    .visible = true,
    .named = true,
  },
  [sym_defset] = {
    .visible = true,
    .named = true,
  },
  [sym_defvar] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_iterator] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_assert] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_bits_type] = {
    .visible = true,
    .named = true,
  },
  [sym_list_type] = {
    .visible = true,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym_paste_value] = {
    .visible = true,
    .named = true,
  },
  [sym_value_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_value_list] = {
    .visible = true,
    .named = true,
  },
  [sym_range_list] = {
    .visible = true,
    .named = true,
  },
  [sym_range_piece] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_value] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_list_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_dag_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_dag_arg_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dag_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_record] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_cond_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_bang_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_cond_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_tablegen_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parent_class_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parent_class_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_let_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multiclass_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_range_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dag_arg_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_class_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_body = 1,
  field_name = 2,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_body] = "body",
  [field_name] = "name",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 2},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 5, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 2},
    {field_name, 1},
  [2] =
    {field_name, 1},
  [3] =
    {field_body, 3},
    {field_name, 1},
  [5] =
    {field_name, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_class_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 5,
  [6] = 6,
  [7] = 6,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 13,
  [15] = 13,
  [16] = 6,
  [17] = 17,
  [18] = 17,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 19,
  [26] = 19,
  [27] = 6,
  [28] = 28,
  [29] = 28,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 33,
  [41] = 36,
  [42] = 35,
  [43] = 43,
  [44] = 32,
  [45] = 43,
  [46] = 39,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 53,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 47,
  [63] = 60,
  [64] = 64,
  [65] = 50,
  [66] = 64,
  [67] = 51,
  [68] = 54,
  [69] = 55,
  [70] = 70,
  [71] = 47,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 61,
  [76] = 61,
  [77] = 47,
  [78] = 60,
  [79] = 64,
  [80] = 50,
  [81] = 51,
  [82] = 54,
  [83] = 55,
  [84] = 84,
  [85] = 47,
  [86] = 84,
  [87] = 47,
  [88] = 88,
  [89] = 89,
  [90] = 89,
  [91] = 91,
  [92] = 59,
  [93] = 72,
  [94] = 61,
  [95] = 61,
  [96] = 61,
  [97] = 84,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 8,
  [102] = 9,
  [103] = 103,
  [104] = 99,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 106,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 99,
  [113] = 113,
  [114] = 114,
  [115] = 99,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 118,
  [120] = 117,
  [121] = 118,
  [122] = 117,
  [123] = 109,
  [124] = 99,
  [125] = 109,
  [126] = 109,
  [127] = 109,
  [128] = 109,
  [129] = 106,
  [130] = 99,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 134,
  [136] = 132,
  [137] = 132,
  [138] = 134,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 140,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 144,
  [151] = 141,
  [152] = 152,
  [153] = 142,
  [154] = 154,
  [155] = 145,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 143,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 164,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 164,
  [177] = 147,
  [178] = 178,
  [179] = 178,
  [180] = 152,
  [181] = 178,
  [182] = 182,
  [183] = 183,
  [184] = 148,
  [185] = 165,
  [186] = 161,
  [187] = 156,
  [188] = 166,
  [189] = 175,
  [190] = 168,
  [191] = 157,
  [192] = 163,
  [193] = 172,
  [194] = 160,
  [195] = 154,
  [196] = 174,
  [197] = 171,
  [198] = 169,
  [199] = 162,
  [200] = 173,
  [201] = 170,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 149,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 219,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 207,
  [237] = 229,
  [238] = 230,
  [239] = 9,
  [240] = 240,
  [241] = 240,
  [242] = 242,
  [243] = 233,
  [244] = 244,
  [245] = 209,
  [246] = 210,
  [247] = 220,
  [248] = 227,
  [249] = 249,
  [250] = 206,
  [251] = 226,
  [252] = 252,
  [253] = 252,
  [254] = 249,
  [255] = 217,
  [256] = 218,
  [257] = 234,
  [258] = 235,
  [259] = 259,
  [260] = 244,
  [261] = 259,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 211,
  [269] = 149,
  [270] = 215,
  [271] = 221,
  [272] = 222,
  [273] = 265,
  [274] = 265,
  [275] = 242,
  [276] = 262,
  [277] = 8,
  [278] = 263,
  [279] = 264,
  [280] = 265,
  [281] = 281,
  [282] = 266,
  [283] = 267,
  [284] = 284,
  [285] = 212,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 290,
  [293] = 291,
  [294] = 294,
  [295] = 289,
  [296] = 288,
  [297] = 291,
  [298] = 183,
  [299] = 215,
  [300] = 222,
  [301] = 219,
  [302] = 233,
  [303] = 212,
  [304] = 207,
  [305] = 206,
  [306] = 226,
  [307] = 229,
  [308] = 230,
  [309] = 252,
  [310] = 240,
  [311] = 242,
  [312] = 249,
  [313] = 217,
  [314] = 218,
  [315] = 209,
  [316] = 210,
  [317] = 234,
  [318] = 220,
  [319] = 221,
  [320] = 227,
  [321] = 265,
  [322] = 244,
  [323] = 259,
  [324] = 262,
  [325] = 263,
  [326] = 264,
  [327] = 265,
  [328] = 266,
  [329] = 267,
  [330] = 211,
  [331] = 235,
  [332] = 139,
  [333] = 333,
  [334] = 334,
  [335] = 145,
  [336] = 183,
  [337] = 334,
  [338] = 142,
  [339] = 334,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 341,
  [344] = 341,
  [345] = 345,
  [346] = 342,
  [347] = 342,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 349,
  [354] = 350,
  [355] = 355,
  [356] = 352,
  [357] = 357,
  [358] = 358,
  [359] = 350,
  [360] = 349,
  [361] = 352,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 366,
  [369] = 366,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 373,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 376,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 183,
  [390] = 376,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 395,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 397,
  [409] = 402,
  [410] = 407,
  [411] = 411,
  [412] = 412,
  [413] = 395,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 423,
  [425] = 423,
  [426] = 403,
  [427] = 427,
  [428] = 403,
  [429] = 429,
  [430] = 430,
  [431] = 403,
  [432] = 403,
  [433] = 433,
  [434] = 403,
  [435] = 396,
  [436] = 396,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 438,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 441,
  [446] = 438,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 441,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 449,
  [459] = 459,
  [460] = 460,
  [461] = 449,
  [462] = 449,
  [463] = 449,
  [464] = 448,
  [465] = 444,
  [466] = 449,
  [467] = 467,
  [468] = 468,
  [469] = 448,
  [470] = 444,
  [471] = 468,
  [472] = 472,
  [473] = 468,
  [474] = 474,
  [475] = 444,
  [476] = 476,
  [477] = 444,
  [478] = 478,
  [479] = 479,
  [480] = 444,
  [481] = 467,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 492,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 506,
  [510] = 501,
  [511] = 503,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 499,
  [518] = 500,
  [519] = 501,
  [520] = 505,
  [521] = 521,
  [522] = 486,
  [523] = 523,
  [524] = 507,
  [525] = 514,
  [526] = 505,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 514,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 532,
  [536] = 536,
  [537] = 537,
  [538] = 489,
  [539] = 539,
  [540] = 512,
  [541] = 500,
  [542] = 532,
  [543] = 543,
  [544] = 536,
  [545] = 490,
  [546] = 546,
  [547] = 547,
  [548] = 487,
  [549] = 549,
  [550] = 501,
  [551] = 485,
  [552] = 505,
  [553] = 521,
  [554] = 554,
  [555] = 555,
  [556] = 515,
  [557] = 529,
  [558] = 501,
  [559] = 505,
  [560] = 501,
  [561] = 505,
  [562] = 529,
  [563] = 494,
  [564] = 528,
  [565] = 565,
  [566] = 487,
  [567] = 537,
  [568] = 485,
  [569] = 569,
  [570] = 536,
  [571] = 571,
  [572] = 499,
  [573] = 486,
  [574] = 495,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(45);
      ADVANCE_MAP(
        '!', 67,
        '"', 76,
        '#', 56,
        '$', 42,
        '(', 65,
        ')', 66,
        '+', 31,
        ',', 51,
        '-', 63,
        '.', 60,
        '/', 4,
        '0', 68,
        ':', 54,
        ';', 55,
        '<', 50,
        '=', 53,
        '>', 52,
        '?', 64,
        '[', 58,
        '\\', 5,
        ']', 59,
        '{', 48,
        '}', 49,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(72);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(76);
      if (lookahead == '#') ADVANCE(79);
      if (lookahead == '/') ADVANCE(78);
      if (lookahead == '\\') ADVANCE(5);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(77);
      if (lookahead != 0) ADVANCE(100);
      END_STATE();
    case 2:
      if (lookahead == '#') ADVANCE(7);
      if (lookahead == '/') ADVANCE(4);
      if (lookahead == '0') ADVANCE(69);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(31);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 3:
      if (lookahead == '.') ADVANCE(61);
      END_STATE();
    case 4:
      if (lookahead == '/') ADVANCE(111);
      END_STATE();
    case 5:
      if (lookahead == 'U') ADVANCE(103);
      if (lookahead == 'u') ADVANCE(24);
      if (lookahead == 'x') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(102);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '?' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(104);
      if (lookahead != 0) ADVANCE(101);
      END_STATE();
    case 6:
      if (lookahead == ']') ADVANCE(106);
      if (lookahead == '}') ADVANCE(27);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 7:
      if (lookahead == 'd') ADVANCE(13);
      if (lookahead == 'e') ADVANCE(21);
      if (lookahead == 'i') ADVANCE(15);
      END_STATE();
    case 8:
      if (lookahead == 'd') ADVANCE(20);
      END_STATE();
    case 9:
      if (lookahead == 'd') ADVANCE(14);
      END_STATE();
    case 10:
      if (lookahead == 'd') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(9);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(29);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(16);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(18);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(10);
      END_STATE();
    case 16:
      if (lookahead == 'f') ADVANCE(19);
      END_STATE();
    case 17:
      if (lookahead == 'f') ADVANCE(46);
      END_STATE();
    case 18:
      if (lookahead == 'f') ADVANCE(29);
      END_STATE();
    case 19:
      if (lookahead == 'i') ADVANCE(22);
      END_STATE();
    case 20:
      if (lookahead == 'i') ADVANCE(17);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(23);
      if (lookahead == 'n') ADVANCE(8);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(12);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(11);
      END_STATE();
    case 24:
      if (lookahead == '{') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 25:
      if (lookahead == '}') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '}') ADVANCE(6);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 27:
      if (lookahead == '}') ADVANCE(27);
      if (lookahead != 0 &&
          lookahead != ']') ADVANCE(26);
      END_STATE();
    case 28:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(71);
      END_STATE();
    case 29:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(30);
      END_STATE();
    case 30:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(30);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(47);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 34:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(25);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 42:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 43:
      if (eof) ADVANCE(45);
      ADVANCE_MAP(
        '!', 67,
        '"', 76,
        '#', 56,
        '$', 42,
        '(', 65,
        ')', 66,
        '+', 31,
        ',', 51,
        '-', 63,
        '.', 60,
        '/', 4,
        '0', 68,
        ':', 54,
        ';', 55,
        '<', 50,
        '=', 53,
        '>', 52,
        '?', 64,
        '[', 58,
        ']', 59,
        '{', 48,
        '}', 49,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(72);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 44:
      if (eof) ADVANCE(45);
      ADVANCE_MAP(
        '"', 76,
        '#', 56,
        ')', 66,
        ',', 51,
        '-', 62,
        '.', 60,
        '/', 4,
        ':', 54,
        ';', 55,
        '<', 50,
        '>', 52,
        '[', 57,
        ']', 59,
        '{', 48,
        '}', 49,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_preprocessor_directive);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_preprocessor_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(47);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == 'd') ADVANCE(13);
      if (lookahead == 'e') ADVANCE(21);
      if (lookahead == 'i') ADVANCE(15);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '{') ADVANCE(26);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(3);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == 'b') ADVANCE(107);
      if (lookahead == 'x') ADVANCE(108);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(72);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == 'b') ADVANCE(28);
      if (lookahead == 'x') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(70);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(71);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_integer);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(72);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_integer);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_integer);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_integer);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '#') ADVANCE(79);
      if (lookahead == '/') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(77);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'd') ADVANCE(85);
      if (lookahead == 'e') ADVANCE(93);
      if (lookahead == 'i') ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'd') ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'd') ADVANCE(86);
      if (lookahead == 'n') ADVANCE(82);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'd') ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'e') ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'e') ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'e') ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'e') ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'f') ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'f') ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'f') ADVANCE(91);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'f') ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'i') ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'i') ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'l') ADVANCE(95);
      if (lookahead == 'n') ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 'n') ADVANCE(84);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == 's') ADVANCE(83);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_string_content);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(97);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_string_content);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_string_content);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(100);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(105);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(104);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_code);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(70);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_var);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(111);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'g', 7,
        'h', 8,
        'i', 9,
        'l', 10,
        'm', 11,
        'n', 12,
        'o', 13,
        's', 14,
        't', 15,
        'x', 16,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'd') ADVANCE(17);
      if (lookahead == 'n') ADVANCE(18);
      if (lookahead == 's') ADVANCE(19);
      END_STATE();
    case 2:
      if (lookahead == 'i') ADVANCE(20);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(21);
      if (lookahead == 'l') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(24);
      if (lookahead == 'e') ADVANCE(25);
      if (lookahead == 'i') ADVANCE(26);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'm') ADVANCE(28);
      if (lookahead == 'q') ADVANCE(29);
      if (lookahead == 'x') ADVANCE(30);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(31);
      if (lookahead == 'i') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(34);
      if (lookahead == 't') ADVANCE(35);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(36);
      END_STATE();
    case 9:
      if (lookahead == 'f') ADVANCE(37);
      if (lookahead == 'n') ADVANCE(38);
      if (lookahead == 's') ADVANCE(39);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(40);
      if (lookahead == 'i') ADVANCE(41);
      if (lookahead == 'o') ADVANCE(42);
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 11:
      if (lookahead == 'u') ADVANCE(44);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(45);
      if (lookahead == 'o') ADVANCE(46);
      END_STATE();
    case 13:
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(48);
      if (lookahead == 'h') ADVANCE(49);
      if (lookahead == 'i') ADVANCE(50);
      if (lookahead == 'r') ADVANCE(51);
      if (lookahead == 't') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'h') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      if (lookahead == 'r') ADVANCE(57);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(58);
      END_STATE();
    case 17:
      if (lookahead == 'd') ADVANCE(59);
      END_STATE();
    case 18:
      if (lookahead == 'd') ADVANCE(60);
      END_STATE();
    case 19:
      if (lookahead == 's') ADVANCE(61);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(62);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(63);
      END_STATE();
    case 22:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 23:
      if (lookahead == 'd') ADVANCE(65);
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 24:
      if (lookahead == 'g') ADVANCE(67);
      END_STATE();
    case 25:
      if (lookahead == 'f') ADVANCE(68);
      END_STATE();
    case 26:
      if (lookahead == 'v') ADVANCE(69);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(70);
      END_STATE();
    case 28:
      if (lookahead == 'p') ADVANCE(71);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_eq);
      END_STATE();
    case 30:
      if (lookahead == 'i') ADVANCE(72);
      END_STATE();
    case 31:
      if (lookahead == 'l') ADVANCE(73);
      END_STATE();
    case 32:
      if (lookahead == 'e') ADVANCE(74);
      if (lookahead == 'l') ADVANCE(75);
      if (lookahead == 'n') ADVANCE(76);
      END_STATE();
    case 33:
      if (lookahead == 'l') ADVANCE(77);
      if (lookahead == 'r') ADVANCE(78);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_ge);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_gt);
      END_STATE();
    case 36:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'c') ADVANCE(81);
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 39:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_le);
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 41:
      if (lookahead == 's') ADVANCE(85);
      END_STATE();
    case 42:
      if (lookahead == 'g') ADVANCE(86);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_lt);
      END_STATE();
    case 44:
      if (lookahead == 'l') ADVANCE(87);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_ne);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 49:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 50:
      if (lookahead == 'z') ADVANCE(91);
      END_STATE();
    case 51:
      if (lookahead == 'a') ADVANCE(92);
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 52:
      if (lookahead == 'r') ADVANCE(94);
      END_STATE();
    case 53:
      if (lookahead == 'b') ADVANCE(95);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 56:
      if (lookahead == 'l') ADVANCE(98);
      if (lookahead == 'u') ADVANCE(99);
      END_STATE();
    case 57:
      if (lookahead == 'u') ADVANCE(100);
      END_STATE();
    case 58:
      if (lookahead == 'r') ADVANCE(101);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_add);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_bit);
      if (lookahead == 's') ADVANCE(103);
      END_STATE();
    case 63:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 64:
      if (lookahead == 's') ADVANCE(105);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_con);
      if (lookahead == 'd') ADVANCE(107);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_dag);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'm') ADVANCE(108);
      if (lookahead == 's') ADVANCE(109);
      if (lookahead == 'v') ADVANCE(110);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_div);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 71:
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 72:
      if (lookahead == 's') ADVANCE(113);
      END_STATE();
    case 73:
      if (lookahead == 's') ADVANCE(114);
      END_STATE();
    case 74:
      if (lookahead == 'l') ADVANCE(115);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 76:
      if (lookahead == 'd') ADVANCE(117);
      END_STATE();
    case 77:
      if (lookahead == 'd') ADVANCE(118);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 79:
      if (lookahead == 'd') ADVANCE(120);
      if (lookahead == 'o') ADVANCE(121);
      END_STATE();
    case 80:
      if (lookahead == 'd') ADVANCE(122);
      END_STATE();
    case 81:
      if (lookahead == 'l') ADVANCE(123);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_isa);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 85:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 86:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_mul);
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 89:
      if (lookahead == 'd') ADVANCE(128);
      if (lookahead == 'o') ADVANCE(129);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_shl);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_sra);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_srl);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(131);
      if (lookahead == 'i') ADVANCE(132);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_sub);
      if (lookahead == 's') ADVANCE(133);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 97:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 98:
      if (lookahead == 'o') ADVANCE(136);
      END_STATE();
    case 99:
      if (lookahead == 'p') ADVANCE(137);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_xor);
      END_STATE();
    case 102:
      if (lookahead == 'r') ADVANCE(139);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_bits);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_cast);
      END_STATE();
    case 105:
      if (lookahead == 's') ADVANCE(140);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_code);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_cond);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_defm);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(141);
      END_STATE();
    case 110:
      if (lookahead == 'a') ADVANCE(142);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 112:
      if (lookahead == 'y') ADVANCE(143);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 115:
      if (lookahead == 'd') ADVANCE(146);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_find);
      END_STATE();
    case 118:
      if (lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 119:
      if (lookahead == 'a') ADVANCE(149);
      END_STATE();
    case 120:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 121:
      if (lookahead == 'p') ADVANCE(151);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_head);
      END_STATE();
    case 123:
      if (lookahead == 'u') ADVANCE(152);
      END_STATE();
    case 124:
      if (lookahead == 'r') ADVANCE(153);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_list);
      if (lookahead == 'c') ADVANCE(154);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == 's') ADVANCE(156);
      END_STATE();
    case 126:
      if (lookahead == 'w') ADVANCE(157);
      END_STATE();
    case 127:
      if (lookahead == 'i') ADVANCE(158);
      END_STATE();
    case 128:
      if (lookahead == 'a') ADVANCE(159);
      END_STATE();
    case 129:
      if (lookahead == 'p') ADVANCE(160);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_size);
      END_STATE();
    case 131:
      if (lookahead == 'o') ADVANCE(161);
      END_STATE();
    case 132:
      if (lookahead == 'n') ADVANCE(162);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_tail);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 136:
      if (lookahead == 'w') ADVANCE(164);
      END_STATE();
    case 137:
      if (lookahead == 'p') ADVANCE(165);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(166);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 141:
      if (lookahead == 't') ADVANCE(167);
      END_STATE();
    case 142:
      if (lookahead == 'r') ADVANCE(168);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_empty);
      END_STATE();
    case 144:
      if (lookahead == 's') ADVANCE(169);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(170);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_foldl);
      END_STATE();
    case 149:
      if (lookahead == 'c') ADVANCE(171);
      END_STATE();
    case 150:
      if (lookahead == 'g') ADVANCE(172);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_getop);
      END_STATE();
    case 152:
      if (lookahead == 'd') ADVANCE(173);
      END_STATE();
    case 153:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 154:
      if (lookahead == 'o') ADVANCE(175);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 156:
      if (lookahead == 'p') ADVANCE(177);
      END_STATE();
    case 157:
      if (lookahead == 'o') ADVANCE(178);
      END_STATE();
    case 158:
      if (lookahead == 'c') ADVANCE(179);
      END_STATE();
    case 159:
      if (lookahead == 'g') ADVANCE(180);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_setop);
      END_STATE();
    case 161:
      if (lookahead == 'n') ADVANCE(181);
      END_STATE();
    case 162:
      if (lookahead == 'g') ADVANCE(182);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_subst);
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 165:
      if (lookahead == 'e') ADVANCE(185);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_defset);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_defvar);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_exists);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_filter);
      END_STATE();
    case 171:
      if (lookahead == 'h') ADVANCE(186);
      END_STATE();
    case 172:
      if (lookahead == 'o') ADVANCE(187);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(189);
      END_STATE();
    case 175:
      if (lookahead == 'n') ADVANCE(190);
      END_STATE();
    case 176:
      if (lookahead == 'm') ADVANCE(191);
      END_STATE();
    case 177:
      if (lookahead == 'l') ADVANCE(192);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_logtwo);
      END_STATE();
    case 179:
      if (lookahead == 'l') ADVANCE(193);
      END_STATE();
    case 180:
      if (lookahead == 'o') ADVANCE(194);
      END_STATE();
    case 181:
      if (lookahead == 'c') ADVANCE(195);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_substr);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(196);
      END_STATE();
    case 185:
      if (lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 187:
      if (lookahead == 'p') ADVANCE(198);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_include);
      END_STATE();
    case 189:
      if (lookahead == 'a') ADVANCE(199);
      END_STATE();
    case 190:
      if (lookahead == 'c') ADVANCE(200);
      END_STATE();
    case 191:
      if (lookahead == 'o') ADVANCE(201);
      END_STATE();
    case 192:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 193:
      if (lookahead == 'a') ADVANCE(203);
      END_STATE();
    case 194:
      if (lookahead == 'p') ADVANCE(204);
      END_STATE();
    case 195:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_tolower);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_toupper);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_getdagop);
      END_STATE();
    case 199:
      if (lookahead == 'v') ADVANCE(206);
      END_STATE();
    case 200:
      if (lookahead == 'a') ADVANCE(207);
      END_STATE();
    case 201:
      if (lookahead == 'v') ADVANCE(208);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(209);
      END_STATE();
    case 203:
      if (lookahead == 's') ADVANCE(210);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_setdagop);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 206:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(213);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_listsplat);
      END_STATE();
    case 210:
      if (lookahead == 's') ADVANCE(215);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_strconcat);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_interleave);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_listconcat);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_listremove);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_multiclass);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 44, .external_lex_state = 1},
  [2] = {.lex_state = 0, .external_lex_state = 1},
  [3] = {.lex_state = 0, .external_lex_state = 1},
  [4] = {.lex_state = 0, .external_lex_state = 1},
  [5] = {.lex_state = 44, .external_lex_state = 1},
  [6] = {.lex_state = 0, .external_lex_state = 1},
  [7] = {.lex_state = 0, .external_lex_state = 1},
  [8] = {.lex_state = 0, .external_lex_state = 1},
  [9] = {.lex_state = 0, .external_lex_state = 1},
  [10] = {.lex_state = 0, .external_lex_state = 1},
  [11] = {.lex_state = 0, .external_lex_state = 1},
  [12] = {.lex_state = 0, .external_lex_state = 1},
  [13] = {.lex_state = 0, .external_lex_state = 1},
  [14] = {.lex_state = 0, .external_lex_state = 1},
  [15] = {.lex_state = 0, .external_lex_state = 1},
  [16] = {.lex_state = 0, .external_lex_state = 1},
  [17] = {.lex_state = 0, .external_lex_state = 1},
  [18] = {.lex_state = 0, .external_lex_state = 1},
  [19] = {.lex_state = 0, .external_lex_state = 1},
  [20] = {.lex_state = 0, .external_lex_state = 1},
  [21] = {.lex_state = 0, .external_lex_state = 1},
  [22] = {.lex_state = 0, .external_lex_state = 1},
  [23] = {.lex_state = 0, .external_lex_state = 1},
  [24] = {.lex_state = 0, .external_lex_state = 1},
  [25] = {.lex_state = 0, .external_lex_state = 1},
  [26] = {.lex_state = 0, .external_lex_state = 1},
  [27] = {.lex_state = 0, .external_lex_state = 1},
  [28] = {.lex_state = 0, .external_lex_state = 1},
  [29] = {.lex_state = 0, .external_lex_state = 1},
  [30] = {.lex_state = 0, .external_lex_state = 1},
  [31] = {.lex_state = 0, .external_lex_state = 1},
  [32] = {.lex_state = 0, .external_lex_state = 1},
  [33] = {.lex_state = 0, .external_lex_state = 1},
  [34] = {.lex_state = 0, .external_lex_state = 1},
  [35] = {.lex_state = 0, .external_lex_state = 1},
  [36] = {.lex_state = 0, .external_lex_state = 1},
  [37] = {.lex_state = 0, .external_lex_state = 1},
  [38] = {.lex_state = 0, .external_lex_state = 1},
  [39] = {.lex_state = 0, .external_lex_state = 1},
  [40] = {.lex_state = 0, .external_lex_state = 1},
  [41] = {.lex_state = 0, .external_lex_state = 1},
  [42] = {.lex_state = 0, .external_lex_state = 1},
  [43] = {.lex_state = 0, .external_lex_state = 1},
  [44] = {.lex_state = 0, .external_lex_state = 1},
  [45] = {.lex_state = 0, .external_lex_state = 1},
  [46] = {.lex_state = 0, .external_lex_state = 1},
  [47] = {.lex_state = 44, .external_lex_state = 1},
  [48] = {.lex_state = 0, .external_lex_state = 1},
  [49] = {.lex_state = 0, .external_lex_state = 1},
  [50] = {.lex_state = 44, .external_lex_state = 1},
  [51] = {.lex_state = 44, .external_lex_state = 1},
  [52] = {.lex_state = 44, .external_lex_state = 1},
  [53] = {.lex_state = 0, .external_lex_state = 1},
  [54] = {.lex_state = 44, .external_lex_state = 1},
  [55] = {.lex_state = 44, .external_lex_state = 1},
  [56] = {.lex_state = 44, .external_lex_state = 1},
  [57] = {.lex_state = 0, .external_lex_state = 1},
  [58] = {.lex_state = 0, .external_lex_state = 1},
  [59] = {.lex_state = 0, .external_lex_state = 1},
  [60] = {.lex_state = 44, .external_lex_state = 1},
  [61] = {.lex_state = 44, .external_lex_state = 1},
  [62] = {.lex_state = 44, .external_lex_state = 1},
  [63] = {.lex_state = 44, .external_lex_state = 1},
  [64] = {.lex_state = 44, .external_lex_state = 1},
  [65] = {.lex_state = 44, .external_lex_state = 1},
  [66] = {.lex_state = 44, .external_lex_state = 1},
  [67] = {.lex_state = 44, .external_lex_state = 1},
  [68] = {.lex_state = 44, .external_lex_state = 1},
  [69] = {.lex_state = 44, .external_lex_state = 1},
  [70] = {.lex_state = 44, .external_lex_state = 1},
  [71] = {.lex_state = 44, .external_lex_state = 1},
  [72] = {.lex_state = 0, .external_lex_state = 1},
  [73] = {.lex_state = 0, .external_lex_state = 1},
  [74] = {.lex_state = 0, .external_lex_state = 1},
  [75] = {.lex_state = 44, .external_lex_state = 1},
  [76] = {.lex_state = 44, .external_lex_state = 1},
  [77] = {.lex_state = 44, .external_lex_state = 1},
  [78] = {.lex_state = 44, .external_lex_state = 1},
  [79] = {.lex_state = 44, .external_lex_state = 1},
  [80] = {.lex_state = 44, .external_lex_state = 1},
  [81] = {.lex_state = 44, .external_lex_state = 1},
  [82] = {.lex_state = 44, .external_lex_state = 1},
  [83] = {.lex_state = 44, .external_lex_state = 1},
  [84] = {.lex_state = 44, .external_lex_state = 1},
  [85] = {.lex_state = 44, .external_lex_state = 1},
  [86] = {.lex_state = 44, .external_lex_state = 1},
  [87] = {.lex_state = 44, .external_lex_state = 1},
  [88] = {.lex_state = 0, .external_lex_state = 1},
  [89] = {.lex_state = 0, .external_lex_state = 1},
  [90] = {.lex_state = 0, .external_lex_state = 1},
  [91] = {.lex_state = 0, .external_lex_state = 1},
  [92] = {.lex_state = 0, .external_lex_state = 1},
  [93] = {.lex_state = 0, .external_lex_state = 1},
  [94] = {.lex_state = 44, .external_lex_state = 1},
  [95] = {.lex_state = 44, .external_lex_state = 1},
  [96] = {.lex_state = 44, .external_lex_state = 1},
  [97] = {.lex_state = 44, .external_lex_state = 1},
  [98] = {.lex_state = 0, .external_lex_state = 1},
  [99] = {.lex_state = 44, .external_lex_state = 1},
  [100] = {.lex_state = 0, .external_lex_state = 1},
  [101] = {.lex_state = 44, .external_lex_state = 1},
  [102] = {.lex_state = 44, .external_lex_state = 1},
  [103] = {.lex_state = 0, .external_lex_state = 1},
  [104] = {.lex_state = 44, .external_lex_state = 1},
  [105] = {.lex_state = 0, .external_lex_state = 1},
  [106] = {.lex_state = 0, .external_lex_state = 1},
  [107] = {.lex_state = 0, .external_lex_state = 1},
  [108] = {.lex_state = 0, .external_lex_state = 1},
  [109] = {.lex_state = 0, .external_lex_state = 1},
  [110] = {.lex_state = 0, .external_lex_state = 1},
  [111] = {.lex_state = 0, .external_lex_state = 1},
  [112] = {.lex_state = 44, .external_lex_state = 1},
  [113] = {.lex_state = 0, .external_lex_state = 1},
  [114] = {.lex_state = 0, .external_lex_state = 1},
  [115] = {.lex_state = 44, .external_lex_state = 1},
  [116] = {.lex_state = 0, .external_lex_state = 1},
  [117] = {.lex_state = 0, .external_lex_state = 1},
  [118] = {.lex_state = 0, .external_lex_state = 1},
  [119] = {.lex_state = 0, .external_lex_state = 1},
  [120] = {.lex_state = 0, .external_lex_state = 1},
  [121] = {.lex_state = 0, .external_lex_state = 1},
  [122] = {.lex_state = 0, .external_lex_state = 1},
  [123] = {.lex_state = 0, .external_lex_state = 1},
  [124] = {.lex_state = 44, .external_lex_state = 1},
  [125] = {.lex_state = 0, .external_lex_state = 1},
  [126] = {.lex_state = 0, .external_lex_state = 1},
  [127] = {.lex_state = 0, .external_lex_state = 1},
  [128] = {.lex_state = 0, .external_lex_state = 1},
  [129] = {.lex_state = 0, .external_lex_state = 1},
  [130] = {.lex_state = 44, .external_lex_state = 1},
  [131] = {.lex_state = 0, .external_lex_state = 1},
  [132] = {.lex_state = 44, .external_lex_state = 1},
  [133] = {.lex_state = 44, .external_lex_state = 1},
  [134] = {.lex_state = 44, .external_lex_state = 1},
  [135] = {.lex_state = 44, .external_lex_state = 1},
  [136] = {.lex_state = 44, .external_lex_state = 1},
  [137] = {.lex_state = 44, .external_lex_state = 1},
  [138] = {.lex_state = 44, .external_lex_state = 1},
  [139] = {.lex_state = 0, .external_lex_state = 1},
  [140] = {.lex_state = 0, .external_lex_state = 1},
  [141] = {.lex_state = 0, .external_lex_state = 1},
  [142] = {.lex_state = 0, .external_lex_state = 1},
  [143] = {.lex_state = 0, .external_lex_state = 1},
  [144] = {.lex_state = 0, .external_lex_state = 1},
  [145] = {.lex_state = 0, .external_lex_state = 1},
  [146] = {.lex_state = 44, .external_lex_state = 1},
  [147] = {.lex_state = 0, .external_lex_state = 1},
  [148] = {.lex_state = 0, .external_lex_state = 1},
  [149] = {.lex_state = 44, .external_lex_state = 1},
  [150] = {.lex_state = 44, .external_lex_state = 1},
  [151] = {.lex_state = 44, .external_lex_state = 1},
  [152] = {.lex_state = 0, .external_lex_state = 1},
  [153] = {.lex_state = 44, .external_lex_state = 1},
  [154] = {.lex_state = 0, .external_lex_state = 1},
  [155] = {.lex_state = 44, .external_lex_state = 1},
  [156] = {.lex_state = 0, .external_lex_state = 1},
  [157] = {.lex_state = 0, .external_lex_state = 1},
  [158] = {.lex_state = 44, .external_lex_state = 1},
  [159] = {.lex_state = 44, .external_lex_state = 1},
  [160] = {.lex_state = 0, .external_lex_state = 1},
  [161] = {.lex_state = 0, .external_lex_state = 1},
  [162] = {.lex_state = 0, .external_lex_state = 1},
  [163] = {.lex_state = 0, .external_lex_state = 1},
  [164] = {.lex_state = 44, .external_lex_state = 1},
  [165] = {.lex_state = 0, .external_lex_state = 1},
  [166] = {.lex_state = 0, .external_lex_state = 1},
  [167] = {.lex_state = 44, .external_lex_state = 1},
  [168] = {.lex_state = 0, .external_lex_state = 1},
  [169] = {.lex_state = 0, .external_lex_state = 1},
  [170] = {.lex_state = 0, .external_lex_state = 1},
  [171] = {.lex_state = 0, .external_lex_state = 1},
  [172] = {.lex_state = 0, .external_lex_state = 1},
  [173] = {.lex_state = 0, .external_lex_state = 1},
  [174] = {.lex_state = 0, .external_lex_state = 1},
  [175] = {.lex_state = 0, .external_lex_state = 1},
  [176] = {.lex_state = 44, .external_lex_state = 1},
  [177] = {.lex_state = 44, .external_lex_state = 1},
  [178] = {.lex_state = 44, .external_lex_state = 1},
  [179] = {.lex_state = 44, .external_lex_state = 1},
  [180] = {.lex_state = 44, .external_lex_state = 1},
  [181] = {.lex_state = 44, .external_lex_state = 1},
  [182] = {.lex_state = 0, .external_lex_state = 1},
  [183] = {.lex_state = 0, .external_lex_state = 1},
  [184] = {.lex_state = 44, .external_lex_state = 1},
  [185] = {.lex_state = 44, .external_lex_state = 1},
  [186] = {.lex_state = 44, .external_lex_state = 1},
  [187] = {.lex_state = 44, .external_lex_state = 1},
  [188] = {.lex_state = 44, .external_lex_state = 1},
  [189] = {.lex_state = 44, .external_lex_state = 1},
  [190] = {.lex_state = 44, .external_lex_state = 1},
  [191] = {.lex_state = 44, .external_lex_state = 1},
  [192] = {.lex_state = 44, .external_lex_state = 1},
  [193] = {.lex_state = 44, .external_lex_state = 1},
  [194] = {.lex_state = 44, .external_lex_state = 1},
  [195] = {.lex_state = 44, .external_lex_state = 1},
  [196] = {.lex_state = 44, .external_lex_state = 1},
  [197] = {.lex_state = 44, .external_lex_state = 1},
  [198] = {.lex_state = 44, .external_lex_state = 1},
  [199] = {.lex_state = 44, .external_lex_state = 1},
  [200] = {.lex_state = 44, .external_lex_state = 1},
  [201] = {.lex_state = 44, .external_lex_state = 1},
  [202] = {.lex_state = 0, .external_lex_state = 1},
  [203] = {.lex_state = 44, .external_lex_state = 1},
  [204] = {.lex_state = 0, .external_lex_state = 1},
  [205] = {.lex_state = 0, .external_lex_state = 1},
  [206] = {.lex_state = 44, .external_lex_state = 1},
  [207] = {.lex_state = 44, .external_lex_state = 1},
  [208] = {.lex_state = 44, .external_lex_state = 1},
  [209] = {.lex_state = 44, .external_lex_state = 1},
  [210] = {.lex_state = 44, .external_lex_state = 1},
  [211] = {.lex_state = 44, .external_lex_state = 1},
  [212] = {.lex_state = 44, .external_lex_state = 1},
  [213] = {.lex_state = 44, .external_lex_state = 1},
  [214] = {.lex_state = 44, .external_lex_state = 1},
  [215] = {.lex_state = 44, .external_lex_state = 1},
  [216] = {.lex_state = 44, .external_lex_state = 1},
  [217] = {.lex_state = 44, .external_lex_state = 1},
  [218] = {.lex_state = 44, .external_lex_state = 1},
  [219] = {.lex_state = 44, .external_lex_state = 1},
  [220] = {.lex_state = 44, .external_lex_state = 1},
  [221] = {.lex_state = 44, .external_lex_state = 1},
  [222] = {.lex_state = 44, .external_lex_state = 1},
  [223] = {.lex_state = 44, .external_lex_state = 1},
  [224] = {.lex_state = 44, .external_lex_state = 1},
  [225] = {.lex_state = 44, .external_lex_state = 1},
  [226] = {.lex_state = 44, .external_lex_state = 1},
  [227] = {.lex_state = 44, .external_lex_state = 1},
  [228] = {.lex_state = 44, .external_lex_state = 1},
  [229] = {.lex_state = 44, .external_lex_state = 1},
  [230] = {.lex_state = 44, .external_lex_state = 1},
  [231] = {.lex_state = 44, .external_lex_state = 1},
  [232] = {.lex_state = 44, .external_lex_state = 1},
  [233] = {.lex_state = 44, .external_lex_state = 1},
  [234] = {.lex_state = 44, .external_lex_state = 1},
  [235] = {.lex_state = 44, .external_lex_state = 1},
  [236] = {.lex_state = 44, .external_lex_state = 1},
  [237] = {.lex_state = 44, .external_lex_state = 1},
  [238] = {.lex_state = 44, .external_lex_state = 1},
  [239] = {.lex_state = 44, .external_lex_state = 1},
  [240] = {.lex_state = 44, .external_lex_state = 1},
  [241] = {.lex_state = 44, .external_lex_state = 1},
  [242] = {.lex_state = 44, .external_lex_state = 1},
  [243] = {.lex_state = 44, .external_lex_state = 1},
  [244] = {.lex_state = 44, .external_lex_state = 1},
  [245] = {.lex_state = 44, .external_lex_state = 1},
  [246] = {.lex_state = 44, .external_lex_state = 1},
  [247] = {.lex_state = 44, .external_lex_state = 1},
  [248] = {.lex_state = 44, .external_lex_state = 1},
  [249] = {.lex_state = 44, .external_lex_state = 1},
  [250] = {.lex_state = 44, .external_lex_state = 1},
  [251] = {.lex_state = 44, .external_lex_state = 1},
  [252] = {.lex_state = 44, .external_lex_state = 1},
  [253] = {.lex_state = 44, .external_lex_state = 1},
  [254] = {.lex_state = 44, .external_lex_state = 1},
  [255] = {.lex_state = 44, .external_lex_state = 1},
  [256] = {.lex_state = 44, .external_lex_state = 1},
  [257] = {.lex_state = 44, .external_lex_state = 1},
  [258] = {.lex_state = 44, .external_lex_state = 1},
  [259] = {.lex_state = 44, .external_lex_state = 1},
  [260] = {.lex_state = 44, .external_lex_state = 1},
  [261] = {.lex_state = 44, .external_lex_state = 1},
  [262] = {.lex_state = 44, .external_lex_state = 1},
  [263] = {.lex_state = 44, .external_lex_state = 1},
  [264] = {.lex_state = 44, .external_lex_state = 1},
  [265] = {.lex_state = 44, .external_lex_state = 1},
  [266] = {.lex_state = 44, .external_lex_state = 1},
  [267] = {.lex_state = 44, .external_lex_state = 1},
  [268] = {.lex_state = 44, .external_lex_state = 1},
  [269] = {.lex_state = 44, .external_lex_state = 1},
  [270] = {.lex_state = 44, .external_lex_state = 1},
  [271] = {.lex_state = 44, .external_lex_state = 1},
  [272] = {.lex_state = 44, .external_lex_state = 1},
  [273] = {.lex_state = 44, .external_lex_state = 1},
  [274] = {.lex_state = 44, .external_lex_state = 1},
  [275] = {.lex_state = 44, .external_lex_state = 1},
  [276] = {.lex_state = 44, .external_lex_state = 1},
  [277] = {.lex_state = 44, .external_lex_state = 1},
  [278] = {.lex_state = 44, .external_lex_state = 1},
  [279] = {.lex_state = 44, .external_lex_state = 1},
  [280] = {.lex_state = 44, .external_lex_state = 1},
  [281] = {.lex_state = 44, .external_lex_state = 1},
  [282] = {.lex_state = 44, .external_lex_state = 1},
  [283] = {.lex_state = 44, .external_lex_state = 1},
  [284] = {.lex_state = 44, .external_lex_state = 1},
  [285] = {.lex_state = 44, .external_lex_state = 1},
  [286] = {.lex_state = 44, .external_lex_state = 1},
  [287] = {.lex_state = 44, .external_lex_state = 1},
  [288] = {.lex_state = 44, .external_lex_state = 1},
  [289] = {.lex_state = 44, .external_lex_state = 1},
  [290] = {.lex_state = 44, .external_lex_state = 1},
  [291] = {.lex_state = 44, .external_lex_state = 1},
  [292] = {.lex_state = 44, .external_lex_state = 1},
  [293] = {.lex_state = 44, .external_lex_state = 1},
  [294] = {.lex_state = 44, .external_lex_state = 1},
  [295] = {.lex_state = 44, .external_lex_state = 1},
  [296] = {.lex_state = 44, .external_lex_state = 1},
  [297] = {.lex_state = 44, .external_lex_state = 1},
  [298] = {.lex_state = 44, .external_lex_state = 1},
  [299] = {.lex_state = 44, .external_lex_state = 1},
  [300] = {.lex_state = 44, .external_lex_state = 1},
  [301] = {.lex_state = 44, .external_lex_state = 1},
  [302] = {.lex_state = 44, .external_lex_state = 1},
  [303] = {.lex_state = 44, .external_lex_state = 1},
  [304] = {.lex_state = 44, .external_lex_state = 1},
  [305] = {.lex_state = 44, .external_lex_state = 1},
  [306] = {.lex_state = 44, .external_lex_state = 1},
  [307] = {.lex_state = 44, .external_lex_state = 1},
  [308] = {.lex_state = 44, .external_lex_state = 1},
  [309] = {.lex_state = 44, .external_lex_state = 1},
  [310] = {.lex_state = 44, .external_lex_state = 1},
  [311] = {.lex_state = 44, .external_lex_state = 1},
  [312] = {.lex_state = 44, .external_lex_state = 1},
  [313] = {.lex_state = 44, .external_lex_state = 1},
  [314] = {.lex_state = 44, .external_lex_state = 1},
  [315] = {.lex_state = 44, .external_lex_state = 1},
  [316] = {.lex_state = 44, .external_lex_state = 1},
  [317] = {.lex_state = 44, .external_lex_state = 1},
  [318] = {.lex_state = 44, .external_lex_state = 1},
  [319] = {.lex_state = 44, .external_lex_state = 1},
  [320] = {.lex_state = 44, .external_lex_state = 1},
  [321] = {.lex_state = 44, .external_lex_state = 1},
  [322] = {.lex_state = 44, .external_lex_state = 1},
  [323] = {.lex_state = 44, .external_lex_state = 1},
  [324] = {.lex_state = 44, .external_lex_state = 1},
  [325] = {.lex_state = 44, .external_lex_state = 1},
  [326] = {.lex_state = 44, .external_lex_state = 1},
  [327] = {.lex_state = 44, .external_lex_state = 1},
  [328] = {.lex_state = 44, .external_lex_state = 1},
  [329] = {.lex_state = 44, .external_lex_state = 1},
  [330] = {.lex_state = 44, .external_lex_state = 1},
  [331] = {.lex_state = 44, .external_lex_state = 1},
  [332] = {.lex_state = 44, .external_lex_state = 1},
  [333] = {.lex_state = 44, .external_lex_state = 1},
  [334] = {.lex_state = 0, .external_lex_state = 1},
  [335] = {.lex_state = 44, .external_lex_state = 1},
  [336] = {.lex_state = 44, .external_lex_state = 1},
  [337] = {.lex_state = 0, .external_lex_state = 1},
  [338] = {.lex_state = 44, .external_lex_state = 1},
  [339] = {.lex_state = 0, .external_lex_state = 1},
  [340] = {.lex_state = 44, .external_lex_state = 1},
  [341] = {.lex_state = 0, .external_lex_state = 1},
  [342] = {.lex_state = 0, .external_lex_state = 1},
  [343] = {.lex_state = 0, .external_lex_state = 1},
  [344] = {.lex_state = 0, .external_lex_state = 1},
  [345] = {.lex_state = 44, .external_lex_state = 1},
  [346] = {.lex_state = 0, .external_lex_state = 1},
  [347] = {.lex_state = 0, .external_lex_state = 1},
  [348] = {.lex_state = 0, .external_lex_state = 1},
  [349] = {.lex_state = 1, .external_lex_state = 1},
  [350] = {.lex_state = 1, .external_lex_state = 1},
  [351] = {.lex_state = 1, .external_lex_state = 1},
  [352] = {.lex_state = 0, .external_lex_state = 1},
  [353] = {.lex_state = 1, .external_lex_state = 1},
  [354] = {.lex_state = 1, .external_lex_state = 1},
  [355] = {.lex_state = 44, .external_lex_state = 1},
  [356] = {.lex_state = 0, .external_lex_state = 1},
  [357] = {.lex_state = 44, .external_lex_state = 1},
  [358] = {.lex_state = 0, .external_lex_state = 1},
  [359] = {.lex_state = 1, .external_lex_state = 1},
  [360] = {.lex_state = 1, .external_lex_state = 1},
  [361] = {.lex_state = 0, .external_lex_state = 1},
  [362] = {.lex_state = 0, .external_lex_state = 1},
  [363] = {.lex_state = 0, .external_lex_state = 1},
  [364] = {.lex_state = 0, .external_lex_state = 1},
  [365] = {.lex_state = 0, .external_lex_state = 1},
  [366] = {.lex_state = 0, .external_lex_state = 1},
  [367] = {.lex_state = 0, .external_lex_state = 1},
  [368] = {.lex_state = 0, .external_lex_state = 1},
  [369] = {.lex_state = 0, .external_lex_state = 1},
  [370] = {.lex_state = 0, .external_lex_state = 1},
  [371] = {.lex_state = 0, .external_lex_state = 1},
  [372] = {.lex_state = 44, .external_lex_state = 1},
  [373] = {.lex_state = 0, .external_lex_state = 1},
  [374] = {.lex_state = 0, .external_lex_state = 1},
  [375] = {.lex_state = 0, .external_lex_state = 1},
  [376] = {.lex_state = 0, .external_lex_state = 1},
  [377] = {.lex_state = 0, .external_lex_state = 1},
  [378] = {.lex_state = 0, .external_lex_state = 1},
  [379] = {.lex_state = 0, .external_lex_state = 1},
  [380] = {.lex_state = 0, .external_lex_state = 1},
  [381] = {.lex_state = 0, .external_lex_state = 1},
  [382] = {.lex_state = 0, .external_lex_state = 1},
  [383] = {.lex_state = 0, .external_lex_state = 1},
  [384] = {.lex_state = 0, .external_lex_state = 1},
  [385] = {.lex_state = 0, .external_lex_state = 1},
  [386] = {.lex_state = 0, .external_lex_state = 1},
  [387] = {.lex_state = 0, .external_lex_state = 1},
  [388] = {.lex_state = 0, .external_lex_state = 1},
  [389] = {.lex_state = 0, .external_lex_state = 1},
  [390] = {.lex_state = 0, .external_lex_state = 1},
  [391] = {.lex_state = 0, .external_lex_state = 1},
  [392] = {.lex_state = 44, .external_lex_state = 1},
  [393] = {.lex_state = 0, .external_lex_state = 1},
  [394] = {.lex_state = 44, .external_lex_state = 1},
  [395] = {.lex_state = 0, .external_lex_state = 1},
  [396] = {.lex_state = 0, .external_lex_state = 1},
  [397] = {.lex_state = 0, .external_lex_state = 1},
  [398] = {.lex_state = 0, .external_lex_state = 1},
  [399] = {.lex_state = 0, .external_lex_state = 1},
  [400] = {.lex_state = 0, .external_lex_state = 1},
  [401] = {.lex_state = 0, .external_lex_state = 1},
  [402] = {.lex_state = 0, .external_lex_state = 1},
  [403] = {.lex_state = 44, .external_lex_state = 1},
  [404] = {.lex_state = 0, .external_lex_state = 1},
  [405] = {.lex_state = 44, .external_lex_state = 1},
  [406] = {.lex_state = 0, .external_lex_state = 1},
  [407] = {.lex_state = 0, .external_lex_state = 1},
  [408] = {.lex_state = 0, .external_lex_state = 1},
  [409] = {.lex_state = 0, .external_lex_state = 1},
  [410] = {.lex_state = 0, .external_lex_state = 1},
  [411] = {.lex_state = 0, .external_lex_state = 1},
  [412] = {.lex_state = 0, .external_lex_state = 1},
  [413] = {.lex_state = 0, .external_lex_state = 1},
  [414] = {.lex_state = 44, .external_lex_state = 1},
  [415] = {.lex_state = 44, .external_lex_state = 1},
  [416] = {.lex_state = 0, .external_lex_state = 1},
  [417] = {.lex_state = 0, .external_lex_state = 1},
  [418] = {.lex_state = 0, .external_lex_state = 1},
  [419] = {.lex_state = 0, .external_lex_state = 1},
  [420] = {.lex_state = 0, .external_lex_state = 1},
  [421] = {.lex_state = 0, .external_lex_state = 1},
  [422] = {.lex_state = 0, .external_lex_state = 1},
  [423] = {.lex_state = 0, .external_lex_state = 1},
  [424] = {.lex_state = 0, .external_lex_state = 1},
  [425] = {.lex_state = 0, .external_lex_state = 1},
  [426] = {.lex_state = 44, .external_lex_state = 1},
  [427] = {.lex_state = 44, .external_lex_state = 1},
  [428] = {.lex_state = 44, .external_lex_state = 1},
  [429] = {.lex_state = 0, .external_lex_state = 1},
  [430] = {.lex_state = 0, .external_lex_state = 1},
  [431] = {.lex_state = 44, .external_lex_state = 1},
  [432] = {.lex_state = 44, .external_lex_state = 1},
  [433] = {.lex_state = 44, .external_lex_state = 1},
  [434] = {.lex_state = 44, .external_lex_state = 1},
  [435] = {.lex_state = 0, .external_lex_state = 1},
  [436] = {.lex_state = 0, .external_lex_state = 1},
  [437] = {.lex_state = 0, .external_lex_state = 1},
  [438] = {.lex_state = 0, .external_lex_state = 1},
  [439] = {.lex_state = 0, .external_lex_state = 1},
  [440] = {.lex_state = 0, .external_lex_state = 1},
  [441] = {.lex_state = 0, .external_lex_state = 1},
  [442] = {.lex_state = 0, .external_lex_state = 1},
  [443] = {.lex_state = 44, .external_lex_state = 1},
  [444] = {.lex_state = 44, .external_lex_state = 1},
  [445] = {.lex_state = 0, .external_lex_state = 1},
  [446] = {.lex_state = 0, .external_lex_state = 1},
  [447] = {.lex_state = 0, .external_lex_state = 1},
  [448] = {.lex_state = 0, .external_lex_state = 1},
  [449] = {.lex_state = 44, .external_lex_state = 1},
  [450] = {.lex_state = 0, .external_lex_state = 1},
  [451] = {.lex_state = 44, .external_lex_state = 1},
  [452] = {.lex_state = 0, .external_lex_state = 1},
  [453] = {.lex_state = 44, .external_lex_state = 1},
  [454] = {.lex_state = 0, .external_lex_state = 1},
  [455] = {.lex_state = 44, .external_lex_state = 1},
  [456] = {.lex_state = 0, .external_lex_state = 1},
  [457] = {.lex_state = 44, .external_lex_state = 1},
  [458] = {.lex_state = 44, .external_lex_state = 1},
  [459] = {.lex_state = 0, .external_lex_state = 1},
  [460] = {.lex_state = 0, .external_lex_state = 1},
  [461] = {.lex_state = 44, .external_lex_state = 1},
  [462] = {.lex_state = 44, .external_lex_state = 1},
  [463] = {.lex_state = 44, .external_lex_state = 1},
  [464] = {.lex_state = 0, .external_lex_state = 1},
  [465] = {.lex_state = 44, .external_lex_state = 1},
  [466] = {.lex_state = 44, .external_lex_state = 1},
  [467] = {.lex_state = 0, .external_lex_state = 1},
  [468] = {.lex_state = 0, .external_lex_state = 1},
  [469] = {.lex_state = 0, .external_lex_state = 1},
  [470] = {.lex_state = 44, .external_lex_state = 1},
  [471] = {.lex_state = 0, .external_lex_state = 1},
  [472] = {.lex_state = 44, .external_lex_state = 1},
  [473] = {.lex_state = 0, .external_lex_state = 1},
  [474] = {.lex_state = 0, .external_lex_state = 1},
  [475] = {.lex_state = 44, .external_lex_state = 1},
  [476] = {.lex_state = 44, .external_lex_state = 1},
  [477] = {.lex_state = 44, .external_lex_state = 1},
  [478] = {.lex_state = 0, .external_lex_state = 1},
  [479] = {.lex_state = 0, .external_lex_state = 1},
  [480] = {.lex_state = 44, .external_lex_state = 1},
  [481] = {.lex_state = 0, .external_lex_state = 1},
  [482] = {.lex_state = 0, .external_lex_state = 1},
  [483] = {.lex_state = 44, .external_lex_state = 1},
  [484] = {.lex_state = 44, .external_lex_state = 1},
  [485] = {.lex_state = 44, .external_lex_state = 1},
  [486] = {.lex_state = 0, .external_lex_state = 1},
  [487] = {.lex_state = 44, .external_lex_state = 1},
  [488] = {.lex_state = 44, .external_lex_state = 1},
  [489] = {.lex_state = 0, .external_lex_state = 1},
  [490] = {.lex_state = 0, .external_lex_state = 1},
  [491] = {.lex_state = 0, .external_lex_state = 1},
  [492] = {.lex_state = 0, .external_lex_state = 1},
  [493] = {.lex_state = 0, .external_lex_state = 1},
  [494] = {.lex_state = 0, .external_lex_state = 1},
  [495] = {.lex_state = 0, .external_lex_state = 1},
  [496] = {.lex_state = 0, .external_lex_state = 1},
  [497] = {.lex_state = 0, .external_lex_state = 1},
  [498] = {.lex_state = 0, .external_lex_state = 1},
  [499] = {.lex_state = 44, .external_lex_state = 1},
  [500] = {.lex_state = 44, .external_lex_state = 1},
  [501] = {.lex_state = 44, .external_lex_state = 1},
  [502] = {.lex_state = 0, .external_lex_state = 1},
  [503] = {.lex_state = 0, .external_lex_state = 1},
  [504] = {.lex_state = 0, .external_lex_state = 1},
  [505] = {.lex_state = 44, .external_lex_state = 1},
  [506] = {.lex_state = 0, .external_lex_state = 1},
  [507] = {.lex_state = 0, .external_lex_state = 1},
  [508] = {.lex_state = 0, .external_lex_state = 1},
  [509] = {.lex_state = 0, .external_lex_state = 1},
  [510] = {.lex_state = 44, .external_lex_state = 1},
  [511] = {.lex_state = 0, .external_lex_state = 1},
  [512] = {.lex_state = 0, .external_lex_state = 1},
  [513] = {.lex_state = 0, .external_lex_state = 1},
  [514] = {.lex_state = 0, .external_lex_state = 1},
  [515] = {.lex_state = 0, .external_lex_state = 1},
  [516] = {.lex_state = 44, .external_lex_state = 1},
  [517] = {.lex_state = 44, .external_lex_state = 1},
  [518] = {.lex_state = 44, .external_lex_state = 1},
  [519] = {.lex_state = 44, .external_lex_state = 1},
  [520] = {.lex_state = 44, .external_lex_state = 1},
  [521] = {.lex_state = 0, .external_lex_state = 1},
  [522] = {.lex_state = 0, .external_lex_state = 1},
  [523] = {.lex_state = 0, .external_lex_state = 1},
  [524] = {.lex_state = 0, .external_lex_state = 1},
  [525] = {.lex_state = 0, .external_lex_state = 1},
  [526] = {.lex_state = 44, .external_lex_state = 1},
  [527] = {.lex_state = 44, .external_lex_state = 1},
  [528] = {.lex_state = 0, .external_lex_state = 1},
  [529] = {.lex_state = 0, .external_lex_state = 1},
  [530] = {.lex_state = 44, .external_lex_state = 1},
  [531] = {.lex_state = 0, .external_lex_state = 1},
  [532] = {.lex_state = 0, .external_lex_state = 1},
  [533] = {.lex_state = 0, .external_lex_state = 1},
  [534] = {.lex_state = 44, .external_lex_state = 1},
  [535] = {.lex_state = 0, .external_lex_state = 1},
  [536] = {.lex_state = 0, .external_lex_state = 1},
  [537] = {.lex_state = 44, .external_lex_state = 1},
  [538] = {.lex_state = 0, .external_lex_state = 1},
  [539] = {.lex_state = 0, .external_lex_state = 1},
  [540] = {.lex_state = 0, .external_lex_state = 1},
  [541] = {.lex_state = 44, .external_lex_state = 1},
  [542] = {.lex_state = 0, .external_lex_state = 1},
  [543] = {.lex_state = 0, .external_lex_state = 1},
  [544] = {.lex_state = 0, .external_lex_state = 1},
  [545] = {.lex_state = 0, .external_lex_state = 1},
  [546] = {.lex_state = 0, .external_lex_state = 1},
  [547] = {.lex_state = 44, .external_lex_state = 1},
  [548] = {.lex_state = 44, .external_lex_state = 1},
  [549] = {.lex_state = 2, .external_lex_state = 1},
  [550] = {.lex_state = 44, .external_lex_state = 1},
  [551] = {.lex_state = 44, .external_lex_state = 1},
  [552] = {.lex_state = 44, .external_lex_state = 1},
  [553] = {.lex_state = 0, .external_lex_state = 1},
  [554] = {.lex_state = 0, .external_lex_state = 1},
  [555] = {.lex_state = 44, .external_lex_state = 1},
  [556] = {.lex_state = 0, .external_lex_state = 1},
  [557] = {.lex_state = 0, .external_lex_state = 1},
  [558] = {.lex_state = 44, .external_lex_state = 1},
  [559] = {.lex_state = 44, .external_lex_state = 1},
  [560] = {.lex_state = 44, .external_lex_state = 1},
  [561] = {.lex_state = 44, .external_lex_state = 1},
  [562] = {.lex_state = 0, .external_lex_state = 1},
  [563] = {.lex_state = 0, .external_lex_state = 1},
  [564] = {.lex_state = 0, .external_lex_state = 1},
  [565] = {.lex_state = 0, .external_lex_state = 1},
  [566] = {.lex_state = 44, .external_lex_state = 1},
  [567] = {.lex_state = 44, .external_lex_state = 1},
  [568] = {.lex_state = 44, .external_lex_state = 1},
  [569] = {.lex_state = 0, .external_lex_state = 1},
  [570] = {.lex_state = 0, .external_lex_state = 1},
  [571] = {.lex_state = 0, .external_lex_state = 1},
  [572] = {.lex_state = 44, .external_lex_state = 1},
  [573] = {.lex_state = 0, .external_lex_state = 1},
  [574] = {.lex_state = 0, .external_lex_state = 1},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_include] = ACTIONS(1),
    [sym_preprocessor_directive] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_code] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_defvar] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_multiclass] = ACTIONS(1),
    [anon_sym_defm] = ACTIONS(1),
    [anon_sym_defset] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_bit] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_dag] = ACTIONS(1),
    [anon_sym_bits] = ACTIONS(1),
    [anon_sym_list] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_cast] = ACTIONS(1),
    [anon_sym_con] = ACTIONS(1),
    [anon_sym_div] = ACTIONS(1),
    [anon_sym_empty] = ACTIONS(1),
    [anon_sym_eq] = ACTIONS(1),
    [anon_sym_exists] = ACTIONS(1),
    [anon_sym_filter] = ACTIONS(1),
    [anon_sym_find] = ACTIONS(1),
    [anon_sym_foldl] = ACTIONS(1),
    [anon_sym_ge] = ACTIONS(1),
    [anon_sym_getop] = ACTIONS(1),
    [anon_sym_getdagop] = ACTIONS(1),
    [anon_sym_gt] = ACTIONS(1),
    [anon_sym_head] = ACTIONS(1),
    [anon_sym_interleave] = ACTIONS(1),
    [anon_sym_isa] = ACTIONS(1),
    [anon_sym_le] = ACTIONS(1),
    [anon_sym_listconcat] = ACTIONS(1),
    [anon_sym_listremove] = ACTIONS(1),
    [anon_sym_listsplat] = ACTIONS(1),
    [anon_sym_logtwo] = ACTIONS(1),
    [anon_sym_lt] = ACTIONS(1),
    [anon_sym_mul] = ACTIONS(1),
    [anon_sym_ne] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_setop] = ACTIONS(1),
    [anon_sym_setdagop] = ACTIONS(1),
    [anon_sym_shl] = ACTIONS(1),
    [anon_sym_size] = ACTIONS(1),
    [anon_sym_sra] = ACTIONS(1),
    [anon_sym_srl] = ACTIONS(1),
    [anon_sym_strconcat] = ACTIONS(1),
    [anon_sym_sub] = ACTIONS(1),
    [anon_sym_subst] = ACTIONS(1),
    [anon_sym_substr] = ACTIONS(1),
    [anon_sym_tail] = ACTIONS(1),
    [anon_sym_tolower] = ACTIONS(1),
    [anon_sym_toupper] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_cond] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym__escape_sequence_token1] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_code] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_var] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_multiline_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_tablegen_file] = STATE(502),
    [sym_include_directive] = STATE(219),
    [sym_statement] = STATE(52),
    [sym_class] = STATE(219),
    [sym_def] = STATE(219),
    [sym_let] = STATE(219),
    [sym_multiclass] = STATE(219),
    [sym_defm] = STATE(219),
    [sym_defset] = STATE(219),
    [sym_defvar] = STATE(219),
    [sym_foreach] = STATE(219),
    [sym_if] = STATE(219),
    [sym_assert] = STATE(219),
    [aux_sym_tablegen_file_repeat1] = STATE(52),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_include] = ACTIONS(7),
    [sym_preprocessor_directive] = ACTIONS(9),
    [anon_sym_class] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_defvar] = ACTIONS(15),
    [anon_sym_def] = ACTIONS(17),
    [anon_sym_multiclass] = ACTIONS(19),
    [anon_sym_defm] = ACTIONS(21),
    [anon_sym_defset] = ACTIONS(23),
    [anon_sym_foreach] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [sym_comment] = ACTIONS(3),
    [sym_multiline_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 31,
    ACTIONS(31), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(35), 1,
      anon_sym_RBRACE,
    ACTIONS(37), 1,
      anon_sym_field,
    ACTIONS(39), 1,
      anon_sym_code,
    ACTIONS(41), 1,
      anon_sym_let,
    ACTIONS(43), 1,
      anon_sym_defvar,
    ACTIONS(45), 1,
      anon_sym_assert,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(512), 1,
      sym_value_list,
    STATE(527), 1,
      sym_type,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(135), 2,
      sym_body_item,
      aux_sym_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
    STATE(208), 4,
      sym_instruction,
      sym_let_instruction,
      sym_def_var,
      sym_assert,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [113] = 31,
    ACTIONS(31), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(37), 1,
      anon_sym_field,
    ACTIONS(39), 1,
      anon_sym_code,
    ACTIONS(41), 1,
      anon_sym_let,
    ACTIONS(43), 1,
      anon_sym_defvar,
    ACTIONS(45), 1,
      anon_sym_assert,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(67), 1,
      anon_sym_RBRACE,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(512), 1,
      sym_value_list,
    STATE(527), 1,
      sym_type,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(134), 2,
      sym_body_item,
      aux_sym_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
    STATE(208), 4,
      sym_instruction,
      sym_let_instruction,
      sym_def_var,
      sym_assert,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [226] = 31,
    ACTIONS(31), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(37), 1,
      anon_sym_field,
    ACTIONS(39), 1,
      anon_sym_code,
    ACTIONS(41), 1,
      anon_sym_let,
    ACTIONS(43), 1,
      anon_sym_defvar,
    ACTIONS(45), 1,
      anon_sym_assert,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(69), 1,
      anon_sym_RBRACE,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(512), 1,
      sym_value_list,
    STATE(527), 1,
      sym_type,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(138), 2,
      sym_body_item,
      aux_sym_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
    STATE(208), 4,
      sym_instruction,
      sym_let_instruction,
      sym_def_var,
      sym_assert,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [339] = 4,
    ACTIONS(75), 1,
      anon_sym_cond,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(73), 4,
      anon_sym_con,
      anon_sym_ge,
      anon_sym_sub,
      anon_sym_subst,
    ACTIONS(71), 41,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_dag,
      anon_sym_add,
      anon_sym_and,
      anon_sym_cast,
      anon_sym_div,
      anon_sym_empty,
      anon_sym_eq,
      anon_sym_exists,
      anon_sym_filter,
      anon_sym_find,
      anon_sym_foldl,
      anon_sym_getop,
      anon_sym_getdagop,
      anon_sym_gt,
      anon_sym_head,
      anon_sym_interleave,
      anon_sym_isa,
      anon_sym_le,
      anon_sym_listconcat,
      anon_sym_listremove,
      anon_sym_listsplat,
      anon_sym_logtwo,
      anon_sym_lt,
      anon_sym_mul,
      anon_sym_ne,
      anon_sym_not,
      anon_sym_or,
      anon_sym_setop,
      anon_sym_setdagop,
      anon_sym_shl,
      anon_sym_size,
      anon_sym_sra,
      anon_sym_srl,
      anon_sym_strconcat,
      anon_sym_substr,
      anon_sym_tail,
      anon_sym_tolower,
      anon_sym_toupper,
      anon_sym_xor,
  [397] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(298), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(81), 3,
      anon_sym_in,
      anon_sym_then,
      anon_sym_POUND,
    ACTIONS(79), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [473] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(332), 1,
      sym_paste_value,
    STATE(336), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(81), 3,
      anon_sym_in,
      anon_sym_POUND,
      anon_sym_DASH,
    ACTIONS(79), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [547] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(85), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
    ACTIONS(83), 18,
      anon_sym_include,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_def,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
  [587] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(89), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
    ACTIONS(87), 18,
      anon_sym_include,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_def,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
  [627] = 21,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(91), 1,
      sym_identifier,
    ACTIONS(93), 1,
      anon_sym_LBRACE,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(97), 1,
      anon_sym_LBRACK,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_RPAREN,
    ACTIONS(105), 1,
      sym_integer,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      sym_var,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(182), 1,
      sym_value,
    STATE(467), 1,
      sym_bang_operator,
    STATE(503), 1,
      sym_cond_operator,
    ACTIONS(99), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(109), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(12), 2,
      sym_dag_arg,
      aux_sym_dag_arg_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [702] = 21,
    ACTIONS(113), 1,
      sym_identifier,
    ACTIONS(116), 1,
      anon_sym_LBRACE,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(122), 1,
      anon_sym_LBRACK,
    ACTIONS(128), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_RPAREN,
    ACTIONS(133), 1,
      anon_sym_BANG,
    ACTIONS(136), 1,
      sym_integer,
    ACTIONS(139), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      sym_var,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(182), 1,
      sym_value,
    STATE(467), 1,
      sym_bang_operator,
    STATE(503), 1,
      sym_cond_operator,
    ACTIONS(125), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(142), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(11), 2,
      sym_dag_arg,
      aux_sym_dag_arg_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [777] = 21,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(91), 1,
      sym_identifier,
    ACTIONS(93), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      anon_sym_LBRACK,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      sym_integer,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      sym_var,
    ACTIONS(148), 1,
      anon_sym_COMMA,
    ACTIONS(150), 1,
      anon_sym_RPAREN,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(182), 1,
      sym_value,
    STATE(467), 1,
      sym_bang_operator,
    STATE(503), 1,
      sym_cond_operator,
    ACTIONS(99), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(109), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(11), 2,
      sym_dag_arg,
      aux_sym_dag_arg_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [852] = 22,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(152), 1,
      anon_sym_LBRACE,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(156), 1,
      anon_sym_SEMI,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(305), 1,
      sym_record_body,
    STATE(306), 1,
      sym_body,
    STATE(338), 1,
      sym_simple_value,
    STATE(343), 1,
      sym_value,
    STATE(425), 1,
      sym_parent_class_list,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [929] = 22,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(158), 1,
      anon_sym_LBRACE,
    ACTIONS(160), 1,
      anon_sym_SEMI,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(206), 1,
      sym_record_body,
    STATE(226), 1,
      sym_body,
    STATE(338), 1,
      sym_simple_value,
    STATE(344), 1,
      sym_value,
    STATE(424), 1,
      sym_parent_class_list,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1006] = 22,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(162), 1,
      anon_sym_LBRACE,
    ACTIONS(164), 1,
      anon_sym_SEMI,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(250), 1,
      sym_record_body,
    STATE(251), 1,
      sym_body,
    STATE(338), 1,
      sym_simple_value,
    STATE(341), 1,
      sym_value,
    STATE(423), 1,
      sym_parent_class_list,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1083] = 19,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(81), 1,
      anon_sym_POUND,
    ACTIONS(91), 1,
      sym_identifier,
    ACTIONS(93), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      anon_sym_LBRACK,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      sym_integer,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(183), 1,
      sym_value,
    STATE(467), 1,
      sym_bang_operator,
    STATE(503), 1,
      sym_cond_operator,
    ACTIONS(99), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(109), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(79), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      sym_var,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1154] = 21,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(91), 1,
      sym_identifier,
    ACTIONS(93), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      anon_sym_LBRACK,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      sym_integer,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      sym_var,
    ACTIONS(166), 1,
      anon_sym_RPAREN,
    STATE(10), 1,
      sym_dag_arg,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(182), 1,
      sym_value,
    STATE(467), 1,
      sym_bang_operator,
    STATE(503), 1,
      sym_cond_operator,
    STATE(563), 1,
      sym_dag_arg_list,
    ACTIONS(99), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(109), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1228] = 21,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(91), 1,
      sym_identifier,
    ACTIONS(93), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      anon_sym_LBRACK,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      sym_integer,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      sym_var,
    ACTIONS(168), 1,
      anon_sym_RPAREN,
    STATE(10), 1,
      sym_dag_arg,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(182), 1,
      sym_value,
    STATE(467), 1,
      sym_bang_operator,
    STATE(494), 1,
      sym_dag_arg_list,
    STATE(503), 1,
      sym_cond_operator,
    ACTIONS(99), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(109), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1302] = 20,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(170), 1,
      anon_sym_SEMI,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(376), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(529), 1,
      sym_parent_class_list,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1373] = 20,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(332), 1,
      sym_paste_value,
    STATE(355), 1,
      sym_value,
    STATE(363), 1,
      sym_range_piece,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(512), 1,
      sym_value_list,
    STATE(533), 1,
      sym_range_list,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1444] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(362), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(172), 3,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1511] = 20,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(91), 1,
      sym_identifier,
    ACTIONS(93), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      anon_sym_LBRACK,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      sym_integer,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      sym_var,
    ACTIONS(150), 1,
      anon_sym_RPAREN,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(182), 1,
      sym_value,
    STATE(202), 1,
      sym_dag_arg,
    STATE(467), 1,
      sym_bang_operator,
    STATE(503), 1,
      sym_cond_operator,
    ACTIONS(99), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(109), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1582] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(362), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(174), 3,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1649] = 20,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(91), 1,
      sym_identifier,
    ACTIONS(93), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      anon_sym_LBRACK,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      sym_integer,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      sym_var,
    ACTIONS(176), 1,
      anon_sym_RPAREN,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(182), 1,
      sym_value,
    STATE(202), 1,
      sym_dag_arg,
    STATE(467), 1,
      sym_bang_operator,
    STATE(503), 1,
      sym_cond_operator,
    ACTIONS(99), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(109), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1720] = 20,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(178), 1,
      anon_sym_SEMI,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(390), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(557), 1,
      sym_parent_class_list,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1791] = 20,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(180), 1,
      anon_sym_SEMI,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(383), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(562), 1,
      sym_parent_class_list,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1862] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(81), 1,
      anon_sym_POUND,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(338), 1,
      sym_simple_value,
    STATE(389), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(79), 2,
      anon_sym_COLON,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [1931] = 20,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(182), 1,
      anon_sym_COMMA,
    ACTIONS(184), 1,
      anon_sym_RPAREN,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(407), 1,
      sym_cond_clause,
    STATE(460), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2002] = 20,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(186), 1,
      anon_sym_COMMA,
    ACTIONS(188), 1,
      anon_sym_RPAREN,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(410), 1,
      sym_cond_clause,
    STATE(460), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2073] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(332), 1,
      sym_paste_value,
    STATE(345), 1,
      sym_value,
    STATE(363), 1,
      sym_range_piece,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(565), 1,
      sym_range_list,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2141] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(190), 1,
      anon_sym_COMMA,
    ACTIONS(192), 1,
      anon_sym_GT,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(386), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2209] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(332), 1,
      sym_paste_value,
    STATE(345), 1,
      sym_value,
    STATE(363), 1,
      sym_range_piece,
    STATE(481), 1,
      sym_bang_operator,
    STATE(506), 1,
      sym_range_list,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2277] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(194), 1,
      anon_sym_RBRACK,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(490), 1,
      sym_value_list,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2345] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(196), 1,
      anon_sym_COMMA,
    ACTIONS(198), 1,
      anon_sym_GT,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(375), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2413] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(200), 1,
      anon_sym_RPAREN,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(459), 1,
      sym_cond_clause,
    STATE(460), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2481] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(202), 1,
      anon_sym_RPAREN,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(459), 1,
      sym_cond_clause,
    STATE(460), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2549] = 19,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(91), 1,
      sym_identifier,
    ACTIONS(93), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      anon_sym_LBRACK,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      sym_integer,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      sym_var,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(182), 1,
      sym_value,
    STATE(202), 1,
      sym_dag_arg,
    STATE(467), 1,
      sym_bang_operator,
    STATE(503), 1,
      sym_cond_operator,
    ACTIONS(99), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(109), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2617] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(332), 1,
      sym_paste_value,
    STATE(345), 1,
      sym_value,
    STATE(363), 1,
      sym_range_piece,
    STATE(481), 1,
      sym_bang_operator,
    STATE(491), 1,
      sym_range_list,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2685] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(332), 1,
      sym_paste_value,
    STATE(345), 1,
      sym_value,
    STATE(363), 1,
      sym_range_piece,
    STATE(481), 1,
      sym_bang_operator,
    STATE(492), 1,
      sym_range_list,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2753] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(204), 1,
      anon_sym_RBRACK,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(545), 1,
      sym_value_list,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2821] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(206), 1,
      anon_sym_RPAREN,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(459), 1,
      sym_cond_clause,
    STATE(460), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2889] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(208), 1,
      anon_sym_RPAREN,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(459), 1,
      sym_cond_clause,
    STATE(460), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [2957] = 19,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(91), 1,
      sym_identifier,
    ACTIONS(93), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      anon_sym_LBRACK,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      sym_integer,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      sym_var,
    STATE(17), 1,
      sym_dag_arg,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(182), 1,
      sym_value,
    STATE(467), 1,
      sym_bang_operator,
    STATE(503), 1,
      sym_cond_operator,
    ACTIONS(99), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(109), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [3025] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(332), 1,
      sym_paste_value,
    STATE(345), 1,
      sym_value,
    STATE(363), 1,
      sym_range_piece,
    STATE(481), 1,
      sym_bang_operator,
    STATE(509), 1,
      sym_range_list,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [3093] = 19,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(91), 1,
      sym_identifier,
    ACTIONS(93), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      anon_sym_LBRACK,
    ACTIONS(101), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      sym_integer,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    ACTIONS(111), 1,
      sym_var,
    STATE(18), 1,
      sym_dag_arg,
    STATE(139), 1,
      sym_paste_value,
    STATE(140), 1,
      sym_string,
    STATE(142), 1,
      sym_simple_value,
    STATE(182), 1,
      sym_value,
    STATE(467), 1,
      sym_bang_operator,
    STATE(503), 1,
      sym_cond_operator,
    ACTIONS(99), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(109), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(165), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [3161] = 19,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(332), 1,
      sym_paste_value,
    STATE(345), 1,
      sym_value,
    STATE(363), 1,
      sym_range_piece,
    STATE(481), 1,
      sym_bang_operator,
    STATE(498), 1,
      sym_range_list,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [3229] = 16,
    ACTIONS(210), 1,
      anon_sym_include,
    ACTIONS(212), 1,
      anon_sym_LBRACE,
    ACTIONS(214), 1,
      anon_sym_class,
    ACTIONS(216), 1,
      anon_sym_let,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(222), 1,
      anon_sym_multiclass,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(226), 1,
      anon_sym_defset,
    ACTIONS(228), 1,
      anon_sym_foreach,
    ACTIONS(230), 1,
      anon_sym_if,
    ACTIONS(232), 1,
      anon_sym_assert,
    STATE(321), 1,
      sym_block,
    STATE(325), 1,
      sym_statement,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(301), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [3290] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_GT,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(362), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [3355] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(236), 1,
      anon_sym_GT,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(362), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [3420] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(240), 1,
      anon_sym_RBRACE,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    STATE(56), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [3479] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(262), 1,
      anon_sym_RBRACE,
    STATE(86), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [3538] = 16,
    ACTIONS(7), 1,
      anon_sym_include,
    ACTIONS(11), 1,
      anon_sym_class,
    ACTIONS(13), 1,
      anon_sym_let,
    ACTIONS(15), 1,
      anon_sym_defvar,
    ACTIONS(17), 1,
      anon_sym_def,
    ACTIONS(19), 1,
      anon_sym_multiclass,
    ACTIONS(21), 1,
      anon_sym_defm,
    ACTIONS(23), 1,
      anon_sym_defset,
    ACTIONS(25), 1,
      anon_sym_foreach,
    ACTIONS(27), 1,
      anon_sym_if,
    ACTIONS(29), 1,
      anon_sym_assert,
    ACTIONS(264), 1,
      ts_builtin_sym_end,
    ACTIONS(266), 1,
      sym_preprocessor_directive,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    STATE(70), 2,
      sym_statement,
      aux_sym_tablegen_file_repeat1,
    STATE(219), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [3599] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_GT,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(378), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [3664] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(270), 1,
      anon_sym_RBRACE,
    STATE(56), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [3723] = 16,
    ACTIONS(7), 1,
      anon_sym_include,
    ACTIONS(11), 1,
      anon_sym_class,
    ACTIONS(13), 1,
      anon_sym_let,
    ACTIONS(15), 1,
      anon_sym_defvar,
    ACTIONS(17), 1,
      anon_sym_def,
    ACTIONS(19), 1,
      anon_sym_multiclass,
    ACTIONS(21), 1,
      anon_sym_defm,
    ACTIONS(23), 1,
      anon_sym_defset,
    ACTIONS(25), 1,
      anon_sym_foreach,
    ACTIONS(27), 1,
      anon_sym_if,
    ACTIONS(29), 1,
      anon_sym_assert,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    STATE(222), 1,
      sym_block,
    STATE(278), 1,
      sym_statement,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(219), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [3784] = 15,
    ACTIONS(274), 1,
      anon_sym_include,
    ACTIONS(277), 1,
      anon_sym_RBRACE,
    ACTIONS(279), 1,
      anon_sym_class,
    ACTIONS(282), 1,
      anon_sym_let,
    ACTIONS(285), 1,
      anon_sym_defvar,
    ACTIONS(288), 1,
      anon_sym_def,
    ACTIONS(291), 1,
      anon_sym_multiclass,
    ACTIONS(294), 1,
      anon_sym_defm,
    ACTIONS(297), 1,
      anon_sym_defset,
    ACTIONS(300), 1,
      anon_sym_foreach,
    ACTIONS(303), 1,
      anon_sym_if,
    ACTIONS(306), 1,
      anon_sym_assert,
    STATE(56), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [3843] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(309), 1,
      anon_sym_GT,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(362), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [3908] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(311), 1,
      anon_sym_GT,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(373), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [3973] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(524), 1,
      sym_value_list,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [4038] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(313), 1,
      anon_sym_RBRACE,
    STATE(50), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4097] = 16,
    ACTIONS(210), 1,
      anon_sym_include,
    ACTIONS(212), 1,
      anon_sym_LBRACE,
    ACTIONS(214), 1,
      anon_sym_class,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(222), 1,
      anon_sym_multiclass,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(226), 1,
      anon_sym_defset,
    ACTIONS(232), 1,
      anon_sym_assert,
    ACTIONS(315), 1,
      anon_sym_let,
    ACTIONS(317), 1,
      anon_sym_foreach,
    ACTIONS(319), 1,
      anon_sym_if,
    STATE(325), 1,
      sym_statement,
    STATE(326), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(301), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4158] = 16,
    ACTIONS(210), 1,
      anon_sym_include,
    ACTIONS(212), 1,
      anon_sym_LBRACE,
    ACTIONS(214), 1,
      anon_sym_class,
    ACTIONS(216), 1,
      anon_sym_let,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(222), 1,
      anon_sym_multiclass,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(226), 1,
      anon_sym_defset,
    ACTIONS(228), 1,
      anon_sym_foreach,
    ACTIONS(230), 1,
      anon_sym_if,
    ACTIONS(232), 1,
      anon_sym_assert,
    STATE(325), 1,
      sym_statement,
    STATE(327), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(301), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4219] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(321), 1,
      anon_sym_RBRACE,
    STATE(65), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4278] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(323), 1,
      anon_sym_RBRACE,
    STATE(68), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4337] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(325), 1,
      anon_sym_RBRACE,
    STATE(56), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4396] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(327), 1,
      anon_sym_RBRACE,
    STATE(54), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4455] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(329), 1,
      anon_sym_RBRACE,
    STATE(97), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4514] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(331), 1,
      anon_sym_RBRACE,
    STATE(56), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4573] = 16,
    ACTIONS(210), 1,
      anon_sym_include,
    ACTIONS(212), 1,
      anon_sym_LBRACE,
    ACTIONS(214), 1,
      anon_sym_class,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(222), 1,
      anon_sym_multiclass,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(226), 1,
      anon_sym_defset,
    ACTIONS(232), 1,
      anon_sym_assert,
    ACTIONS(315), 1,
      anon_sym_let,
    ACTIONS(317), 1,
      anon_sym_foreach,
    ACTIONS(319), 1,
      anon_sym_if,
    STATE(300), 1,
      sym_block,
    STATE(325), 1,
      sym_statement,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(301), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4634] = 16,
    ACTIONS(333), 1,
      ts_builtin_sym_end,
    ACTIONS(335), 1,
      anon_sym_include,
    ACTIONS(338), 1,
      sym_preprocessor_directive,
    ACTIONS(341), 1,
      anon_sym_class,
    ACTIONS(344), 1,
      anon_sym_let,
    ACTIONS(347), 1,
      anon_sym_defvar,
    ACTIONS(350), 1,
      anon_sym_def,
    ACTIONS(353), 1,
      anon_sym_multiclass,
    ACTIONS(356), 1,
      anon_sym_defm,
    ACTIONS(359), 1,
      anon_sym_defset,
    ACTIONS(362), 1,
      anon_sym_foreach,
    ACTIONS(365), 1,
      anon_sym_if,
    ACTIONS(368), 1,
      anon_sym_assert,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    STATE(70), 2,
      sym_statement,
      aux_sym_tablegen_file_repeat1,
    STATE(219), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4695] = 16,
    ACTIONS(7), 1,
      anon_sym_include,
    ACTIONS(11), 1,
      anon_sym_class,
    ACTIONS(15), 1,
      anon_sym_defvar,
    ACTIONS(17), 1,
      anon_sym_def,
    ACTIONS(19), 1,
      anon_sym_multiclass,
    ACTIONS(21), 1,
      anon_sym_defm,
    ACTIONS(23), 1,
      anon_sym_defset,
    ACTIONS(29), 1,
      anon_sym_assert,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    ACTIONS(371), 1,
      anon_sym_let,
    ACTIONS(373), 1,
      anon_sym_foreach,
    ACTIONS(375), 1,
      anon_sym_if,
    STATE(278), 1,
      sym_statement,
    STATE(280), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(219), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [4756] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(495), 1,
      sym_value_list,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [4821] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(332), 1,
      sym_paste_value,
    STATE(345), 1,
      sym_value,
    STATE(371), 1,
      sym_range_piece,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [4886] = 18,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(377), 1,
      anon_sym_LBRACE,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(332), 1,
      sym_paste_value,
    STATE(372), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(483), 1,
      sym_range_piece,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [4951] = 16,
    ACTIONS(7), 1,
      anon_sym_include,
    ACTIONS(11), 1,
      anon_sym_class,
    ACTIONS(13), 1,
      anon_sym_let,
    ACTIONS(15), 1,
      anon_sym_defvar,
    ACTIONS(17), 1,
      anon_sym_def,
    ACTIONS(19), 1,
      anon_sym_multiclass,
    ACTIONS(21), 1,
      anon_sym_defm,
    ACTIONS(23), 1,
      anon_sym_defset,
    ACTIONS(25), 1,
      anon_sym_foreach,
    ACTIONS(27), 1,
      anon_sym_if,
    ACTIONS(29), 1,
      anon_sym_assert,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(219), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5012] = 16,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    STATE(263), 1,
      sym_statement,
    STATE(264), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5073] = 16,
    ACTIONS(7), 1,
      anon_sym_include,
    ACTIONS(11), 1,
      anon_sym_class,
    ACTIONS(15), 1,
      anon_sym_defvar,
    ACTIONS(17), 1,
      anon_sym_def,
    ACTIONS(19), 1,
      anon_sym_multiclass,
    ACTIONS(21), 1,
      anon_sym_defm,
    ACTIONS(23), 1,
      anon_sym_defset,
    ACTIONS(29), 1,
      anon_sym_assert,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    ACTIONS(371), 1,
      anon_sym_let,
    ACTIONS(373), 1,
      anon_sym_foreach,
    ACTIONS(375), 1,
      anon_sym_if,
    STATE(265), 1,
      sym_block,
    STATE(278), 1,
      sym_statement,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(219), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5134] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(381), 1,
      anon_sym_RBRACE,
    STATE(80), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5193] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(383), 1,
      anon_sym_RBRACE,
    STATE(82), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5252] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(385), 1,
      anon_sym_RBRACE,
    STATE(56), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5311] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(387), 1,
      anon_sym_RBRACE,
    STATE(84), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5370] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(389), 1,
      anon_sym_RBRACE,
    STATE(56), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5429] = 16,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    STATE(263), 1,
      sym_statement,
    STATE(272), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5490] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(391), 1,
      anon_sym_RBRACE,
    STATE(56), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5549] = 16,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(393), 1,
      anon_sym_let,
    ACTIONS(395), 1,
      anon_sym_foreach,
    ACTIONS(397), 1,
      anon_sym_if,
    STATE(263), 1,
      sym_statement,
    STATE(273), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5610] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(399), 1,
      anon_sym_RBRACE,
    STATE(56), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5669] = 16,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(393), 1,
      anon_sym_let,
    ACTIONS(395), 1,
      anon_sym_foreach,
    ACTIONS(397), 1,
      anon_sym_if,
    STATE(263), 1,
      sym_statement,
    STATE(274), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [5730] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    ACTIONS(401), 1,
      anon_sym_GT,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(362), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [5795] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(540), 1,
      sym_value_list,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [5860] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(512), 1,
      sym_value_list,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [5925] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(459), 1,
      sym_cond_clause,
    STATE(460), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [5990] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(507), 1,
      sym_value_list,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [6055] = 18,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(358), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    STATE(574), 1,
      sym_value_list,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [6120] = 16,
    ACTIONS(7), 1,
      anon_sym_include,
    ACTIONS(11), 1,
      anon_sym_class,
    ACTIONS(15), 1,
      anon_sym_defvar,
    ACTIONS(17), 1,
      anon_sym_def,
    ACTIONS(19), 1,
      anon_sym_multiclass,
    ACTIONS(21), 1,
      anon_sym_defm,
    ACTIONS(23), 1,
      anon_sym_defset,
    ACTIONS(29), 1,
      anon_sym_assert,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    ACTIONS(371), 1,
      anon_sym_let,
    ACTIONS(373), 1,
      anon_sym_foreach,
    ACTIONS(375), 1,
      anon_sym_if,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(219), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [6181] = 16,
    ACTIONS(210), 1,
      anon_sym_include,
    ACTIONS(212), 1,
      anon_sym_LBRACE,
    ACTIONS(214), 1,
      anon_sym_class,
    ACTIONS(216), 1,
      anon_sym_let,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(222), 1,
      anon_sym_multiclass,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(226), 1,
      anon_sym_defset,
    ACTIONS(228), 1,
      anon_sym_foreach,
    ACTIONS(230), 1,
      anon_sym_if,
    ACTIONS(232), 1,
      anon_sym_assert,
    STATE(325), 1,
      sym_statement,
    STATE(326), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(301), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [6242] = 16,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(393), 1,
      anon_sym_let,
    ACTIONS(395), 1,
      anon_sym_foreach,
    ACTIONS(397), 1,
      anon_sym_if,
    STATE(263), 1,
      sym_statement,
    STATE(264), 1,
      sym_block,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [6303] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(403), 1,
      anon_sym_RBRACE,
    STATE(56), 2,
      sym_statement,
      aux_sym_block_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [6362] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(405), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [6424] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(393), 1,
      anon_sym_let,
    ACTIONS(395), 1,
      anon_sym_foreach,
    ACTIONS(397), 1,
      anon_sym_if,
    ACTIONS(405), 1,
      anon_sym_LBRACE,
    STATE(260), 1,
      sym_statement,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [6482] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(479), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [6544] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(83), 3,
      anon_sym_def,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(85), 21,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_in,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_then,
      anon_sym_else,
      anon_sym_assert,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [6578] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(87), 3,
      anon_sym_def,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(89), 21,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_in,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_then,
      anon_sym_else,
      anon_sym_assert,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
  [6612] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(357), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [6674] = 15,
    ACTIONS(210), 1,
      anon_sym_include,
    ACTIONS(214), 1,
      anon_sym_class,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(222), 1,
      anon_sym_multiclass,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(226), 1,
      anon_sym_defset,
    ACTIONS(232), 1,
      anon_sym_assert,
    ACTIONS(315), 1,
      anon_sym_let,
    ACTIONS(317), 1,
      anon_sym_foreach,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(407), 1,
      anon_sym_LBRACE,
    STATE(322), 1,
      sym_statement,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(301), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [6732] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(478), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [6794] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(473), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [6856] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(447), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [6918] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(471), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [6980] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(466), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7042] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(362), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7104] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(422), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7166] = 15,
    ACTIONS(238), 1,
      anon_sym_include,
    ACTIONS(242), 1,
      anon_sym_class,
    ACTIONS(244), 1,
      anon_sym_let,
    ACTIONS(246), 1,
      anon_sym_defvar,
    ACTIONS(248), 1,
      anon_sym_def,
    ACTIONS(250), 1,
      anon_sym_multiclass,
    ACTIONS(252), 1,
      anon_sym_defm,
    ACTIONS(254), 1,
      anon_sym_defset,
    ACTIONS(256), 1,
      anon_sym_foreach,
    ACTIONS(258), 1,
      anon_sym_if,
    ACTIONS(260), 1,
      anon_sym_assert,
    ACTIONS(405), 1,
      anon_sym_LBRACE,
    STATE(260), 1,
      sym_statement,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(232), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [7224] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(393), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7286] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(394), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7348] = 15,
    ACTIONS(7), 1,
      anon_sym_include,
    ACTIONS(11), 1,
      anon_sym_class,
    ACTIONS(13), 1,
      anon_sym_let,
    ACTIONS(15), 1,
      anon_sym_defvar,
    ACTIONS(17), 1,
      anon_sym_def,
    ACTIONS(19), 1,
      anon_sym_multiclass,
    ACTIONS(21), 1,
      anon_sym_defm,
    ACTIONS(23), 1,
      anon_sym_defset,
    ACTIONS(25), 1,
      anon_sym_foreach,
    ACTIONS(27), 1,
      anon_sym_if,
    ACTIONS(29), 1,
      anon_sym_assert,
    ACTIONS(409), 1,
      anon_sym_LBRACE,
    STATE(244), 1,
      sym_statement,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(219), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [7406] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(456), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7468] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(445), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7530] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(438), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7592] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(446), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7654] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(454), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7716] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(440), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7778] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(441), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7840] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(449), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [7902] = 15,
    ACTIONS(7), 1,
      anon_sym_include,
    ACTIONS(11), 1,
      anon_sym_class,
    ACTIONS(15), 1,
      anon_sym_defvar,
    ACTIONS(17), 1,
      anon_sym_def,
    ACTIONS(19), 1,
      anon_sym_multiclass,
    ACTIONS(21), 1,
      anon_sym_defm,
    ACTIONS(23), 1,
      anon_sym_defset,
    ACTIONS(29), 1,
      anon_sym_assert,
    ACTIONS(371), 1,
      anon_sym_let,
    ACTIONS(373), 1,
      anon_sym_foreach,
    ACTIONS(375), 1,
      anon_sym_if,
    ACTIONS(409), 1,
      anon_sym_LBRACE,
    STATE(244), 1,
      sym_statement,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(219), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [7960] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(458), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [8022] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(461), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [8084] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(462), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [8146] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(463), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [8208] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(468), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [8270] = 15,
    ACTIONS(210), 1,
      anon_sym_include,
    ACTIONS(214), 1,
      anon_sym_class,
    ACTIONS(216), 1,
      anon_sym_let,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(222), 1,
      anon_sym_multiclass,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(226), 1,
      anon_sym_defset,
    ACTIONS(228), 1,
      anon_sym_foreach,
    ACTIONS(230), 1,
      anon_sym_if,
    ACTIONS(232), 1,
      anon_sym_assert,
    ACTIONS(407), 1,
      anon_sym_LBRACE,
    STATE(322), 1,
      sym_statement,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(301), 11,
      sym_include_directive,
      sym_class,
      sym_def,
      sym_let,
      sym_multiclass,
      sym_defm,
      sym_defset,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [8328] = 17,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LPAREN,
    ACTIONS(59), 1,
      anon_sym_BANG,
    ACTIONS(61), 1,
      sym_integer,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      sym_identifier,
    STATE(139), 1,
      sym_paste_value,
    STATE(146), 1,
      sym_string,
    STATE(153), 1,
      sym_simple_value,
    STATE(474), 1,
      sym_value,
    STATE(481), 1,
      sym_bang_operator,
    STATE(511), 1,
      sym_cond_operator,
    ACTIONS(55), 2,
      anon_sym_QMARK,
      sym_code,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(185), 7,
      sym_sequence,
      sym_list_initializer,
      sym_dag_initializer,
      sym_anonymous_record,
      sym_concatenated_string,
      sym_operator,
      sym_boolean,
  [8390] = 15,
    ACTIONS(37), 1,
      anon_sym_field,
    ACTIONS(39), 1,
      anon_sym_code,
    ACTIONS(41), 1,
      anon_sym_let,
    ACTIONS(43), 1,
      anon_sym_defvar,
    ACTIONS(45), 1,
      anon_sym_assert,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(67), 1,
      anon_sym_RBRACE,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(527), 1,
      sym_type,
    STATE(134), 2,
      sym_body_item,
      aux_sym_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
    STATE(208), 4,
      sym_instruction,
      sym_let_instruction,
      sym_def_var,
      sym_assert,
  [8447] = 15,
    ACTIONS(413), 1,
      sym_identifier,
    ACTIONS(416), 1,
      anon_sym_RBRACE,
    ACTIONS(418), 1,
      anon_sym_field,
    ACTIONS(421), 1,
      anon_sym_code,
    ACTIONS(424), 1,
      anon_sym_let,
    ACTIONS(427), 1,
      anon_sym_defvar,
    ACTIONS(430), 1,
      anon_sym_assert,
    ACTIONS(436), 1,
      anon_sym_bits,
    ACTIONS(439), 1,
      anon_sym_list,
    STATE(527), 1,
      sym_type,
    STATE(133), 2,
      sym_body_item,
      aux_sym_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(433), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
    STATE(208), 4,
      sym_instruction,
      sym_let_instruction,
      sym_def_var,
      sym_assert,
  [8504] = 15,
    ACTIONS(37), 1,
      anon_sym_field,
    ACTIONS(39), 1,
      anon_sym_code,
    ACTIONS(41), 1,
      anon_sym_let,
    ACTIONS(43), 1,
      anon_sym_defvar,
    ACTIONS(45), 1,
      anon_sym_assert,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_RBRACE,
    STATE(527), 1,
      sym_type,
    STATE(133), 2,
      sym_body_item,
      aux_sym_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
    STATE(208), 4,
      sym_instruction,
      sym_let_instruction,
      sym_def_var,
      sym_assert,
  [8561] = 15,
    ACTIONS(37), 1,
      anon_sym_field,
    ACTIONS(39), 1,
      anon_sym_code,
    ACTIONS(41), 1,
      anon_sym_let,
    ACTIONS(43), 1,
      anon_sym_defvar,
    ACTIONS(45), 1,
      anon_sym_assert,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    ACTIONS(444), 1,
      anon_sym_RBRACE,
    STATE(527), 1,
      sym_type,
    STATE(133), 2,
      sym_body_item,
      aux_sym_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
    STATE(208), 4,
      sym_instruction,
      sym_let_instruction,
      sym_def_var,
      sym_assert,
  [8618] = 15,
    ACTIONS(35), 1,
      anon_sym_RBRACE,
    ACTIONS(37), 1,
      anon_sym_field,
    ACTIONS(39), 1,
      anon_sym_code,
    ACTIONS(41), 1,
      anon_sym_let,
    ACTIONS(43), 1,
      anon_sym_defvar,
    ACTIONS(45), 1,
      anon_sym_assert,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(527), 1,
      sym_type,
    STATE(135), 2,
      sym_body_item,
      aux_sym_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
    STATE(208), 4,
      sym_instruction,
      sym_let_instruction,
      sym_def_var,
      sym_assert,
  [8675] = 15,
    ACTIONS(37), 1,
      anon_sym_field,
    ACTIONS(39), 1,
      anon_sym_code,
    ACTIONS(41), 1,
      anon_sym_let,
    ACTIONS(43), 1,
      anon_sym_defvar,
    ACTIONS(45), 1,
      anon_sym_assert,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(69), 1,
      anon_sym_RBRACE,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(527), 1,
      sym_type,
    STATE(138), 2,
      sym_body_item,
      aux_sym_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
    STATE(208), 4,
      sym_instruction,
      sym_let_instruction,
      sym_def_var,
      sym_assert,
  [8732] = 15,
    ACTIONS(37), 1,
      anon_sym_field,
    ACTIONS(39), 1,
      anon_sym_code,
    ACTIONS(41), 1,
      anon_sym_let,
    ACTIONS(43), 1,
      anon_sym_defvar,
    ACTIONS(45), 1,
      anon_sym_assert,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    ACTIONS(446), 1,
      anon_sym_RBRACE,
    STATE(527), 1,
      sym_type,
    STATE(133), 2,
      sym_body_item,
      aux_sym_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
    STATE(208), 4,
      sym_instruction,
      sym_let_instruction,
      sym_def_var,
      sym_assert,
  [8789] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(448), 8,
      anon_sym_in,
      anon_sym_then,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(450), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [8821] = 5,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    STATE(141), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(452), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(454), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      sym_code,
      sym_var,
  [8854] = 5,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    STATE(144), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(456), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(458), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      sym_code,
      sym_var,
  [8887] = 5,
    ACTIONS(460), 1,
      anon_sym_DOT,
    STATE(145), 2,
      sym_value_suffix,
      aux_sym_value_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(448), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(450), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [8920] = 7,
    ACTIONS(464), 1,
      anon_sym_LBRACE,
    ACTIONS(469), 1,
      anon_sym_LBRACK,
    ACTIONS(472), 1,
      anon_sym_DOT,
    STATE(143), 2,
      sym_value_suffix,
      aux_sym_value_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(462), 5,
      anon_sym_POUND,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(467), 9,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [8957] = 5,
    ACTIONS(479), 1,
      anon_sym_DQUOTE,
    STATE(144), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(475), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(477), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      sym_code,
      sym_var,
  [8990] = 5,
    ACTIONS(460), 1,
      anon_sym_DOT,
    STATE(143), 2,
      sym_value_suffix,
      aux_sym_value_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(482), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(484), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9023] = 5,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    STATE(151), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(454), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [9055] = 4,
    ACTIONS(486), 1,
      anon_sym_LT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(452), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(454), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9085] = 4,
    ACTIONS(492), 1,
      anon_sym_LT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(488), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(490), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9115] = 3,
    ACTIONS(496), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(494), 17,
      anon_sym_field,
      anon_sym_code,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_def,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
      anon_sym_bits,
      anon_sym_list,
      sym_identifier,
  [9143] = 5,
    ACTIONS(498), 1,
      anon_sym_DQUOTE,
    ACTIONS(475), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    STATE(150), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(477), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [9175] = 5,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    ACTIONS(456), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    STATE(150), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(458), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [9207] = 4,
    ACTIONS(505), 1,
      anon_sym_LT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(501), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(503), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9237] = 7,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(511), 1,
      anon_sym_DOT,
    STATE(155), 2,
      sym_value_suffix,
      aux_sym_value_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(450), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [9272] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(513), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(515), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9299] = 7,
    ACTIONS(482), 1,
      anon_sym_POUND,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(511), 1,
      anon_sym_DOT,
    STATE(159), 2,
      sym_value_suffix,
      aux_sym_value_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(484), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [9334] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(517), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(519), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9361] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(521), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(523), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9388] = 11,
    ACTIONS(525), 1,
      anon_sym_RBRACE,
    ACTIONS(527), 1,
      anon_sym_let,
    ACTIONS(530), 1,
      anon_sym_defvar,
    ACTIONS(533), 1,
      anon_sym_def,
    ACTIONS(536), 1,
      anon_sym_defm,
    ACTIONS(539), 1,
      anon_sym_foreach,
    ACTIONS(542), 1,
      anon_sym_if,
    ACTIONS(545), 1,
      anon_sym_assert,
    STATE(158), 2,
      sym_multiclass_statement,
      aux_sym_multiclass_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(333), 7,
      sym_def,
      sym_let,
      sym_defm,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [9431] = 7,
    ACTIONS(462), 1,
      anon_sym_POUND,
    ACTIONS(548), 1,
      anon_sym_LBRACE,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(554), 1,
      anon_sym_DOT,
    STATE(159), 2,
      sym_value_suffix,
      aux_sym_value_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(467), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [9466] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(557), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(559), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9493] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(561), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(563), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9520] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(565), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(567), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9547] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(569), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(571), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9574] = 11,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(232), 1,
      anon_sym_assert,
    ACTIONS(315), 1,
      anon_sym_let,
    ACTIONS(317), 1,
      anon_sym_foreach,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(573), 1,
      anon_sym_RBRACE,
    STATE(158), 2,
      sym_multiclass_statement,
      aux_sym_multiclass_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(333), 7,
      sym_def,
      sym_let,
      sym_defm,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [9617] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(452), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(454), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9644] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(575), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(577), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9671] = 11,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(232), 1,
      anon_sym_assert,
    ACTIONS(315), 1,
      anon_sym_let,
    ACTIONS(317), 1,
      anon_sym_foreach,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(579), 1,
      anon_sym_RBRACE,
    STATE(158), 2,
      sym_multiclass_statement,
      aux_sym_multiclass_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(333), 7,
      sym_def,
      sym_let,
      sym_defm,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [9714] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(581), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(583), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9741] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(585), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(587), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9768] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(589), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(591), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9795] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(593), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(595), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9822] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(597), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(599), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9849] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(601), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(603), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9876] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(605), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(607), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9903] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(609), 6,
      anon_sym_POUND,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(611), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [9930] = 11,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(232), 1,
      anon_sym_assert,
    ACTIONS(315), 1,
      anon_sym_let,
    ACTIONS(317), 1,
      anon_sym_foreach,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(613), 1,
      anon_sym_RBRACE,
    STATE(158), 2,
      sym_multiclass_statement,
      aux_sym_multiclass_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(333), 7,
      sym_def,
      sym_let,
      sym_defm,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [9973] = 4,
    ACTIONS(615), 1,
      anon_sym_LT,
    ACTIONS(452), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(454), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10001] = 10,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(232), 1,
      anon_sym_assert,
    ACTIONS(315), 1,
      anon_sym_let,
    ACTIONS(317), 1,
      anon_sym_foreach,
    ACTIONS(319), 1,
      anon_sym_if,
    STATE(167), 2,
      sym_multiclass_statement,
      aux_sym_multiclass_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(333), 7,
      sym_def,
      sym_let,
      sym_defm,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [10041] = 10,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(232), 1,
      anon_sym_assert,
    ACTIONS(315), 1,
      anon_sym_let,
    ACTIONS(317), 1,
      anon_sym_foreach,
    ACTIONS(319), 1,
      anon_sym_if,
    STATE(176), 2,
      sym_multiclass_statement,
      aux_sym_multiclass_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(333), 7,
      sym_def,
      sym_let,
      sym_defm,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [10081] = 4,
    ACTIONS(617), 1,
      anon_sym_LT,
    ACTIONS(501), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(503), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10109] = 10,
    ACTIONS(218), 1,
      anon_sym_defvar,
    ACTIONS(220), 1,
      anon_sym_def,
    ACTIONS(224), 1,
      anon_sym_defm,
    ACTIONS(232), 1,
      anon_sym_assert,
    ACTIONS(315), 1,
      anon_sym_let,
    ACTIONS(317), 1,
      anon_sym_foreach,
    ACTIONS(319), 1,
      anon_sym_if,
    STATE(164), 2,
      sym_multiclass_statement,
      aux_sym_multiclass_body_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(333), 7,
      sym_def,
      sym_let,
      sym_defm,
      sym_defvar,
      sym_foreach,
      sym_if,
      sym_assert,
  [10149] = 5,
    ACTIONS(623), 1,
      anon_sym_COLON,
    ACTIONS(625), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(619), 5,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(621), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [10179] = 4,
    ACTIONS(625), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(627), 5,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(629), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [10207] = 4,
    ACTIONS(631), 1,
      anon_sym_LT,
    ACTIONS(488), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(490), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10235] = 3,
    ACTIONS(452), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(454), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10260] = 3,
    ACTIONS(561), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(563), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10285] = 3,
    ACTIONS(517), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(519), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10310] = 3,
    ACTIONS(575), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(577), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10335] = 3,
    ACTIONS(609), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(611), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10360] = 3,
    ACTIONS(581), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(583), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10385] = 3,
    ACTIONS(521), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(523), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10410] = 3,
    ACTIONS(569), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(571), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10435] = 3,
    ACTIONS(597), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(599), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10460] = 3,
    ACTIONS(557), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(559), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10485] = 3,
    ACTIONS(513), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(515), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10510] = 3,
    ACTIONS(605), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(607), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10535] = 3,
    ACTIONS(593), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(595), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10560] = 3,
    ACTIONS(585), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(587), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10585] = 3,
    ACTIONS(565), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(567), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10610] = 3,
    ACTIONS(601), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(603), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10635] = 3,
    ACTIONS(589), 2,
      anon_sym_POUND,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(591), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_RPAREN,
  [10660] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(633), 5,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(131), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [10684] = 10,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    ACTIONS(635), 1,
      anon_sym_COMMA,
    ACTIONS(637), 1,
      anon_sym_GT,
    STATE(400), 1,
      sym_template_arg,
    STATE(534), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [10722] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(619), 5,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(621), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [10746] = 3,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(639), 5,
      anon_sym_LBRACK,
      sym_integer,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(641), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_code,
      sym_var,
  [10770] = 3,
    ACTIONS(645), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(643), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [10793] = 3,
    ACTIONS(649), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(647), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [10816] = 3,
    ACTIONS(653), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(651), 12,
      anon_sym_field,
      anon_sym_code,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_assert,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
      anon_sym_bits,
      anon_sym_list,
      sym_identifier,
  [10839] = 3,
    ACTIONS(657), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(655), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [10862] = 3,
    ACTIONS(661), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(659), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [10885] = 3,
    ACTIONS(665), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(663), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [10908] = 3,
    ACTIONS(669), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(667), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [10931] = 3,
    ACTIONS(494), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(496), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [10954] = 9,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    ACTIONS(671), 1,
      anon_sym_GT,
    STATE(452), 1,
      sym_template_arg,
    STATE(534), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [10989] = 3,
    ACTIONS(675), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(673), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11012] = 3,
    ACTIONS(679), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(677), 12,
      anon_sym_field,
      anon_sym_code,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_assert,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
      anon_sym_bits,
      anon_sym_list,
      sym_identifier,
  [11035] = 3,
    ACTIONS(683), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(681), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11058] = 3,
    ACTIONS(687), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(685), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11081] = 3,
    ACTIONS(691), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(689), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11104] = 3,
    ACTIONS(695), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(693), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11127] = 3,
    ACTIONS(699), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(697), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11150] = 3,
    ACTIONS(703), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(701), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11173] = 3,
    ACTIONS(707), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(705), 12,
      anon_sym_field,
      anon_sym_code,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_assert,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
      anon_sym_bits,
      anon_sym_list,
      sym_identifier,
  [11196] = 3,
    ACTIONS(711), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(709), 12,
      anon_sym_field,
      anon_sym_code,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_assert,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
      anon_sym_bits,
      anon_sym_list,
      sym_identifier,
  [11219] = 3,
    ACTIONS(715), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(713), 12,
      anon_sym_field,
      anon_sym_code,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_assert,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
      anon_sym_bits,
      anon_sym_list,
      sym_identifier,
  [11242] = 3,
    ACTIONS(719), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(717), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11265] = 3,
    ACTIONS(723), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(721), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11288] = 3,
    ACTIONS(727), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(725), 12,
      anon_sym_field,
      anon_sym_code,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_assert,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
      anon_sym_bits,
      anon_sym_list,
      sym_identifier,
  [11311] = 3,
    ACTIONS(731), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(729), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11334] = 3,
    ACTIONS(735), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(733), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11357] = 3,
    ACTIONS(739), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(737), 12,
      anon_sym_field,
      anon_sym_code,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_assert,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
      anon_sym_bits,
      anon_sym_list,
      sym_identifier,
  [11380] = 3,
    ACTIONS(691), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(689), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11403] = 3,
    ACTIONS(743), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(741), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11426] = 3,
    ACTIONS(747), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(745), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11449] = 3,
    ACTIONS(751), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(749), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11472] = 3,
    ACTIONS(649), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(647), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11495] = 3,
    ACTIONS(731), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(729), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11518] = 3,
    ACTIONS(735), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(733), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11541] = 3,
    ACTIONS(87), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(89), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11564] = 3,
    ACTIONS(755), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(753), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11587] = 3,
    ACTIONS(755), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(753), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11610] = 3,
    ACTIONS(759), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(757), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11633] = 3,
    ACTIONS(743), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(741), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11656] = 3,
    ACTIONS(763), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(761), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11679] = 3,
    ACTIONS(657), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(655), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11702] = 3,
    ACTIONS(661), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(659), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11725] = 3,
    ACTIONS(695), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(693), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11748] = 3,
    ACTIONS(723), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(721), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11771] = 3,
    ACTIONS(767), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(765), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11794] = 3,
    ACTIONS(645), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(643), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11817] = 3,
    ACTIONS(719), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(717), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11840] = 3,
    ACTIONS(771), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(769), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11863] = 3,
    ACTIONS(771), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(769), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11886] = 3,
    ACTIONS(767), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(765), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11909] = 3,
    ACTIONS(683), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(681), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11932] = 3,
    ACTIONS(687), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(685), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11955] = 3,
    ACTIONS(747), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(745), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [11978] = 3,
    ACTIONS(751), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(749), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12001] = 3,
    ACTIONS(775), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(773), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12024] = 3,
    ACTIONS(763), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(761), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12047] = 3,
    ACTIONS(775), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(773), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12070] = 3,
    ACTIONS(779), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(777), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12093] = 3,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(781), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12116] = 3,
    ACTIONS(787), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(785), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12139] = 3,
    ACTIONS(791), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(789), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12162] = 3,
    ACTIONS(795), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(793), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12185] = 3,
    ACTIONS(799), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(797), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12208] = 3,
    ACTIONS(665), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(663), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12231] = 3,
    ACTIONS(494), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(496), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12254] = 3,
    ACTIONS(675), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(673), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12277] = 3,
    ACTIONS(699), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(697), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12300] = 3,
    ACTIONS(703), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(701), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12323] = 4,
    ACTIONS(791), 1,
      anon_sym_def,
    ACTIONS(801), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(789), 11,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_assert,
  [12348] = 3,
    ACTIONS(791), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(789), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12371] = 3,
    ACTIONS(759), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(757), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12394] = 3,
    ACTIONS(779), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(777), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12417] = 3,
    ACTIONS(83), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(85), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12440] = 3,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(781), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12463] = 3,
    ACTIONS(787), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(785), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12486] = 4,
    ACTIONS(791), 1,
      anon_sym_def,
    ACTIONS(803), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(789), 12,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_assert,
  [12511] = 9,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    ACTIONS(805), 1,
      anon_sym_GT,
    STATE(452), 1,
      sym_template_arg,
    STATE(534), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12546] = 3,
    ACTIONS(795), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(793), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12569] = 3,
    ACTIONS(799), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_multiline_comment,
      sym_comment,
    ACTIONS(797), 13,
      ts_builtin_sym_end,
      anon_sym_include,
      sym_preprocessor_directive,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12592] = 3,
    ACTIONS(809), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(807), 12,
      anon_sym_field,
      anon_sym_code,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_assert,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
      anon_sym_bits,
      anon_sym_list,
      sym_identifier,
  [12615] = 3,
    ACTIONS(669), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(667), 12,
      anon_sym_include,
      anon_sym_RBRACE,
      anon_sym_class,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_multiclass,
      anon_sym_defm,
      anon_sym_defset,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [12638] = 8,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    ACTIONS(811), 1,
      anon_sym_code,
    STATE(484), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12670] = 8,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(452), 1,
      sym_template_arg,
    STATE(534), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12702] = 7,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(521), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12731] = 7,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(528), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12760] = 7,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(556), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12789] = 7,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(568), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12818] = 7,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(515), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12847] = 7,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(485), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12876] = 7,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(571), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12905] = 7,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(564), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12934] = 7,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(553), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12963] = 7,
    ACTIONS(49), 1,
      anon_sym_bits,
    ACTIONS(51), 1,
      anon_sym_list,
    ACTIONS(411), 1,
      sym_identifier,
    STATE(551), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    STATE(451), 3,
      sym_primitive_type,
      sym_bits_type,
      sym_list_type,
    ACTIONS(47), 4,
      anon_sym_bit,
      anon_sym_int,
      anon_sym_string,
      anon_sym_dag,
  [12992] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(629), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_then,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [13012] = 3,
    ACTIONS(675), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(673), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13031] = 3,
    ACTIONS(703), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(701), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13050] = 3,
    ACTIONS(691), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(689), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13069] = 3,
    ACTIONS(743), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(741), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13088] = 3,
    ACTIONS(669), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(667), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13107] = 3,
    ACTIONS(649), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(647), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13126] = 3,
    ACTIONS(645), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(643), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13145] = 3,
    ACTIONS(719), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(717), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13164] = 3,
    ACTIONS(731), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(729), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13183] = 3,
    ACTIONS(735), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(733), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13202] = 3,
    ACTIONS(771), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(769), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13221] = 3,
    ACTIONS(755), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(753), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13240] = 3,
    ACTIONS(759), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(757), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13259] = 3,
    ACTIONS(767), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(765), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13278] = 3,
    ACTIONS(683), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(681), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13297] = 3,
    ACTIONS(687), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(685), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13316] = 3,
    ACTIONS(657), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(655), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13335] = 3,
    ACTIONS(661), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(659), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13354] = 3,
    ACTIONS(747), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(745), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13373] = 3,
    ACTIONS(695), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(693), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13392] = 3,
    ACTIONS(699), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(697), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13411] = 3,
    ACTIONS(723), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(721), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13430] = 3,
    ACTIONS(791), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(789), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13449] = 3,
    ACTIONS(763), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(761), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13468] = 3,
    ACTIONS(775), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(773), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13487] = 3,
    ACTIONS(779), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(777), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13506] = 3,
    ACTIONS(783), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(781), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13525] = 3,
    ACTIONS(787), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(785), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13544] = 4,
    ACTIONS(791), 1,
      anon_sym_def,
    ACTIONS(815), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(789), 7,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_assert,
  [13565] = 3,
    ACTIONS(795), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(793), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13584] = 3,
    ACTIONS(799), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(797), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13603] = 3,
    ACTIONS(665), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(663), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13622] = 3,
    ACTIONS(751), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(749), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_else,
      anon_sym_assert,
  [13641] = 3,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(450), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
  [13659] = 3,
    ACTIONS(819), 1,
      anon_sym_def,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(817), 7,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_defvar,
      anon_sym_defm,
      anon_sym_foreach,
      anon_sym_if,
      anon_sym_assert,
  [13677] = 9,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(156), 1,
      anon_sym_SEMI,
    ACTIONS(821), 1,
      anon_sym_LBRACE,
    ACTIONS(823), 1,
      anon_sym_LT,
    STATE(304), 1,
      sym_record_body,
    STATE(306), 1,
      sym_body,
    STATE(352), 1,
      sym_template_args,
    STATE(425), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [13707] = 6,
    ACTIONS(482), 1,
      anon_sym_POUND,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(825), 1,
      anon_sym_DOT,
    STATE(159), 2,
      sym_value_suffix,
      aux_sym_value_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(484), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [13731] = 3,
    ACTIONS(827), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(629), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
  [13749] = 9,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(160), 1,
      anon_sym_SEMI,
    ACTIONS(823), 1,
      anon_sym_LT,
    ACTIONS(829), 1,
      anon_sym_LBRACE,
    STATE(207), 1,
      sym_record_body,
    STATE(226), 1,
      sym_body,
    STATE(361), 1,
      sym_template_args,
    STATE(424), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [13779] = 6,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(509), 1,
      anon_sym_LBRACK,
    ACTIONS(825), 1,
      anon_sym_DOT,
    STATE(335), 2,
      sym_value_suffix,
      aux_sym_value_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(450), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [13803] = 9,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(164), 1,
      anon_sym_SEMI,
    ACTIONS(823), 1,
      anon_sym_LT,
    ACTIONS(831), 1,
      anon_sym_LBRACE,
    STATE(236), 1,
      sym_record_body,
    STATE(251), 1,
      sym_body,
    STATE(356), 1,
      sym_template_args,
    STATE(423), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [13833] = 5,
    ACTIONS(452), 1,
      anon_sym_POUND,
    ACTIONS(615), 1,
      anon_sym_LT,
    ACTIONS(833), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(454), 5,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [13855] = 8,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(164), 1,
      anon_sym_SEMI,
    ACTIONS(831), 1,
      anon_sym_LBRACE,
    ACTIONS(835), 1,
      anon_sym_POUND,
    STATE(251), 1,
      sym_body,
    STATE(256), 1,
      sym_record_body,
    STATE(423), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [13882] = 8,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(823), 1,
      anon_sym_LT,
    ACTIONS(837), 1,
      anon_sym_LBRACE,
    ACTIONS(839), 1,
      anon_sym_SEMI,
    STATE(308), 1,
      sym_multiclass_body,
    STATE(366), 1,
      sym_template_args,
    STATE(435), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [13909] = 8,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(156), 1,
      anon_sym_SEMI,
    ACTIONS(821), 1,
      anon_sym_LBRACE,
    ACTIONS(835), 1,
      anon_sym_POUND,
    STATE(306), 1,
      sym_body,
    STATE(314), 1,
      sym_record_body,
    STATE(425), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [13936] = 8,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(160), 1,
      anon_sym_SEMI,
    ACTIONS(829), 1,
      anon_sym_LBRACE,
    ACTIONS(835), 1,
      anon_sym_POUND,
    STATE(218), 1,
      sym_record_body,
    STATE(226), 1,
      sym_body,
    STATE(424), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [13963] = 4,
    ACTIONS(827), 1,
      anon_sym_POUND,
    ACTIONS(843), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(841), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACK,
  [13982] = 8,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(823), 1,
      anon_sym_LT,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(847), 1,
      anon_sym_SEMI,
    STATE(230), 1,
      sym_multiclass_body,
    STATE(369), 1,
      sym_template_args,
    STATE(436), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14009] = 8,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(823), 1,
      anon_sym_LT,
    ACTIONS(849), 1,
      anon_sym_LBRACE,
    ACTIONS(851), 1,
      anon_sym_SEMI,
    STATE(238), 1,
      sym_multiclass_body,
    STATE(368), 1,
      sym_template_args,
    STATE(396), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14036] = 4,
    ACTIONS(855), 1,
      anon_sym_COMMA,
    STATE(348), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(853), 4,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [14054] = 6,
    ACTIONS(3), 1,
      sym_multiline_comment,
    ACTIONS(860), 1,
      anon_sym_DQUOTE,
    ACTIONS(862), 1,
      sym_string_content,
    ACTIONS(858), 2,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(864), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(359), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
  [14076] = 6,
    ACTIONS(3), 1,
      sym_multiline_comment,
    ACTIONS(866), 1,
      anon_sym_DQUOTE,
    ACTIONS(868), 1,
      sym_string_content,
    ACTIONS(858), 2,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(870), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(351), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
  [14098] = 6,
    ACTIONS(3), 1,
      sym_multiline_comment,
    ACTIONS(872), 1,
      anon_sym_DQUOTE,
    ACTIONS(874), 1,
      sym_string_content,
    ACTIONS(858), 2,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(877), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(351), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
  [14120] = 7,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(156), 1,
      anon_sym_SEMI,
    ACTIONS(821), 1,
      anon_sym_LBRACE,
    STATE(306), 1,
      sym_body,
    STATE(310), 1,
      sym_record_body,
    STATE(425), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14144] = 6,
    ACTIONS(3), 1,
      sym_multiline_comment,
    ACTIONS(880), 1,
      anon_sym_DQUOTE,
    ACTIONS(882), 1,
      sym_string_content,
    ACTIONS(858), 2,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(884), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(354), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
  [14166] = 6,
    ACTIONS(3), 1,
      sym_multiline_comment,
    ACTIONS(868), 1,
      sym_string_content,
    ACTIONS(886), 1,
      anon_sym_DQUOTE,
    ACTIONS(858), 2,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(870), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(351), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
  [14188] = 5,
    ACTIONS(827), 1,
      anon_sym_POUND,
    STATE(364), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(841), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(843), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14208] = 7,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(164), 1,
      anon_sym_SEMI,
    ACTIONS(831), 1,
      anon_sym_LBRACE,
    STATE(240), 1,
      sym_record_body,
    STATE(251), 1,
      sym_body,
    STATE(423), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14232] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(888), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_RBRACK,
  [14248] = 5,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(892), 1,
      anon_sym_COMMA,
    STATE(364), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(890), 3,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [14268] = 6,
    ACTIONS(3), 1,
      sym_multiline_comment,
    ACTIONS(868), 1,
      sym_string_content,
    ACTIONS(894), 1,
      anon_sym_DQUOTE,
    ACTIONS(858), 2,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(870), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(351), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
  [14290] = 6,
    ACTIONS(3), 1,
      sym_multiline_comment,
    ACTIONS(896), 1,
      anon_sym_DQUOTE,
    ACTIONS(898), 1,
      sym_string_content,
    ACTIONS(858), 2,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(900), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(350), 2,
      sym__escape_sequence,
      aux_sym_string_repeat1,
  [14312] = 7,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(160), 1,
      anon_sym_SEMI,
    ACTIONS(829), 1,
      anon_sym_LBRACE,
    STATE(226), 1,
      sym_body,
    STATE(241), 1,
      sym_record_body,
    STATE(424), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14336] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(853), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [14352] = 4,
    ACTIONS(904), 1,
      anon_sym_COMMA,
    STATE(365), 1,
      aux_sym_range_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(902), 3,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_RBRACK,
  [14369] = 4,
    ACTIONS(906), 1,
      anon_sym_COMMA,
    STATE(348), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(172), 3,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [14386] = 4,
    ACTIONS(904), 1,
      anon_sym_COMMA,
    STATE(367), 1,
      aux_sym_range_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(908), 3,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_RBRACK,
  [14403] = 6,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(837), 1,
      anon_sym_LBRACE,
    ACTIONS(839), 1,
      anon_sym_SEMI,
    STATE(311), 1,
      sym_multiclass_body,
    STATE(395), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14424] = 4,
    ACTIONS(912), 1,
      anon_sym_COMMA,
    STATE(367), 1,
      aux_sym_range_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(910), 3,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_RBRACK,
  [14441] = 6,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(849), 1,
      anon_sym_LBRACE,
    ACTIONS(851), 1,
      anon_sym_SEMI,
    STATE(242), 1,
      sym_multiclass_body,
    STATE(401), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14462] = 6,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(847), 1,
      anon_sym_SEMI,
    STATE(275), 1,
      sym_multiclass_body,
    STATE(413), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14483] = 5,
    ACTIONS(917), 1,
      anon_sym_LT,
    ACTIONS(919), 1,
      anon_sym_COMMA,
    STATE(380), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(915), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14502] = 2,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(910), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACK,
  [14514] = 4,
    ACTIONS(827), 1,
      anon_sym_POUND,
    ACTIONS(841), 1,
      anon_sym_in,
    ACTIONS(843), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14530] = 5,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(921), 1,
      anon_sym_COMMA,
    ACTIONS(923), 1,
      anon_sym_GT,
    STATE(408), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14548] = 4,
    ACTIONS(919), 1,
      anon_sym_COMMA,
    STATE(388), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(925), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14564] = 5,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(927), 1,
      anon_sym_COMMA,
    ACTIONS(929), 1,
      anon_sym_GT,
    STATE(411), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14582] = 5,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(931), 1,
      anon_sym_SEMI,
    STATE(486), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14600] = 4,
    ACTIONS(919), 1,
      anon_sym_COMMA,
    STATE(381), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(925), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14616] = 5,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(921), 1,
      anon_sym_COMMA,
    ACTIONS(933), 1,
      anon_sym_GT,
    STATE(397), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14634] = 4,
    ACTIONS(919), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(935), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14650] = 4,
    ACTIONS(919), 1,
      anon_sym_COMMA,
    STATE(388), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(937), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14666] = 4,
    ACTIONS(919), 1,
      anon_sym_COMMA,
    STATE(388), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(935), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14682] = 4,
    ACTIONS(919), 1,
      anon_sym_COMMA,
    STATE(391), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(939), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14698] = 5,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(941), 1,
      anon_sym_SEMI,
    STATE(573), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14716] = 4,
    ACTIONS(919), 1,
      anon_sym_COMMA,
    STATE(388), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(939), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14732] = 4,
    ACTIONS(919), 1,
      anon_sym_COMMA,
    STATE(374), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(943), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14748] = 5,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(945), 1,
      anon_sym_COMMA,
    ACTIONS(947), 1,
      anon_sym_GT,
    STATE(404), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14766] = 3,
    ACTIONS(951), 1,
      anon_sym_LT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(949), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [14780] = 4,
    ACTIONS(953), 1,
      anon_sym_COMMA,
    STATE(388), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(949), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14796] = 3,
    ACTIONS(835), 1,
      anon_sym_POUND,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(629), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [14810] = 5,
    ACTIONS(154), 1,
      anon_sym_COLON,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(956), 1,
      anon_sym_SEMI,
    STATE(522), 1,
      sym_parent_class_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14828] = 4,
    ACTIONS(919), 1,
      anon_sym_COMMA,
    STATE(388), 1,
      aux_sym_parent_class_list_repeat2,
    ACTIONS(958), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14844] = 4,
    ACTIONS(960), 1,
      anon_sym_COMMA,
    ACTIONS(962), 1,
      anon_sym_in,
    STATE(415), 1,
      aux_sym_let_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14859] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(964), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14872] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(966), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14885] = 4,
    ACTIONS(837), 1,
      anon_sym_LBRACE,
    ACTIONS(839), 1,
      anon_sym_SEMI,
    STATE(316), 1,
      sym_multiclass_body,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14900] = 4,
    ACTIONS(849), 1,
      anon_sym_LBRACE,
    ACTIONS(851), 1,
      anon_sym_SEMI,
    STATE(242), 1,
      sym_multiclass_body,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14915] = 4,
    ACTIONS(921), 1,
      anon_sym_COMMA,
    ACTIONS(968), 1,
      anon_sym_GT,
    STATE(348), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14930] = 2,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(970), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [14941] = 2,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(972), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [14952] = 4,
    ACTIONS(974), 1,
      anon_sym_COMMA,
    ACTIONS(976), 1,
      anon_sym_GT,
    STATE(419), 1,
      aux_sym_template_args_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14967] = 4,
    ACTIONS(849), 1,
      anon_sym_LBRACE,
    ACTIONS(851), 1,
      anon_sym_SEMI,
    STATE(246), 1,
      sym_multiclass_body,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14982] = 4,
    ACTIONS(200), 1,
      anon_sym_RPAREN,
    ACTIONS(978), 1,
      anon_sym_COMMA,
    STATE(429), 1,
      aux_sym_operator_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [14997] = 4,
    ACTIONS(980), 1,
      sym_identifier,
    STATE(427), 1,
      sym_let_item,
    STATE(510), 1,
      sym_let_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15012] = 4,
    ACTIONS(309), 1,
      anon_sym_GT,
    ACTIONS(982), 1,
      anon_sym_COMMA,
    STATE(348), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15027] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(984), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15040] = 2,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(986), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [15051] = 4,
    ACTIONS(988), 1,
      anon_sym_COMMA,
    ACTIONS(990), 1,
      anon_sym_RPAREN,
    STATE(409), 1,
      aux_sym_operator_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15066] = 4,
    ACTIONS(921), 1,
      anon_sym_COMMA,
    ACTIONS(992), 1,
      anon_sym_GT,
    STATE(348), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15081] = 4,
    ACTIONS(208), 1,
      anon_sym_RPAREN,
    ACTIONS(994), 1,
      anon_sym_COMMA,
    STATE(429), 1,
      aux_sym_operator_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15096] = 4,
    ACTIONS(996), 1,
      anon_sym_COMMA,
    ACTIONS(998), 1,
      anon_sym_RPAREN,
    STATE(402), 1,
      aux_sym_operator_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15111] = 4,
    ACTIONS(234), 1,
      anon_sym_GT,
    ACTIONS(1000), 1,
      anon_sym_COMMA,
    STATE(348), 1,
      aux_sym_parent_class_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15126] = 2,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(1002), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [15137] = 4,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(847), 1,
      anon_sym_SEMI,
    STATE(210), 1,
      sym_multiclass_body,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15152] = 4,
    ACTIONS(1004), 1,
      sym_identifier,
    ACTIONS(1006), 1,
      anon_sym_in,
    STATE(472), 1,
      sym_let_item,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15167] = 4,
    ACTIONS(1008), 1,
      anon_sym_COMMA,
    ACTIONS(1011), 1,
      anon_sym_in,
    STATE(415), 1,
      aux_sym_let_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15182] = 2,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(1013), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [15193] = 2,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(1015), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [15204] = 2,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(1017), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [15215] = 4,
    ACTIONS(805), 1,
      anon_sym_GT,
    ACTIONS(1019), 1,
      anon_sym_COMMA,
    STATE(430), 1,
      aux_sym_template_args_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15230] = 3,
    ACTIONS(1023), 1,
      anon_sym_EQ,
    ACTIONS(1021), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15243] = 2,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
    ACTIONS(1025), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [15254] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1027), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15267] = 4,
    ACTIONS(164), 1,
      anon_sym_SEMI,
    ACTIONS(831), 1,
      anon_sym_LBRACE,
    STATE(255), 1,
      sym_body,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15282] = 4,
    ACTIONS(160), 1,
      anon_sym_SEMI,
    ACTIONS(829), 1,
      anon_sym_LBRACE,
    STATE(217), 1,
      sym_body,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15297] = 4,
    ACTIONS(156), 1,
      anon_sym_SEMI,
    ACTIONS(821), 1,
      anon_sym_LBRACE,
    STATE(313), 1,
      sym_body,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15312] = 4,
    ACTIONS(980), 1,
      sym_identifier,
    STATE(427), 1,
      sym_let_item,
    STATE(501), 1,
      sym_let_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15327] = 4,
    ACTIONS(1029), 1,
      anon_sym_COMMA,
    ACTIONS(1031), 1,
      anon_sym_in,
    STATE(392), 1,
      aux_sym_let_list_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15342] = 4,
    ACTIONS(980), 1,
      sym_identifier,
    STATE(427), 1,
      sym_let_item,
    STATE(519), 1,
      sym_let_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15357] = 4,
    ACTIONS(1033), 1,
      anon_sym_COMMA,
    ACTIONS(1036), 1,
      anon_sym_RPAREN,
    STATE(429), 1,
      aux_sym_operator_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15372] = 4,
    ACTIONS(1038), 1,
      anon_sym_COMMA,
    ACTIONS(1041), 1,
      anon_sym_GT,
    STATE(430), 1,
      aux_sym_template_args_repeat1,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15387] = 4,
    ACTIONS(980), 1,
      sym_identifier,
    STATE(427), 1,
      sym_let_item,
    STATE(558), 1,
      sym_let_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15402] = 4,
    ACTIONS(980), 1,
      sym_identifier,
    STATE(427), 1,
      sym_let_item,
    STATE(560), 1,
      sym_let_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15417] = 4,
    ACTIONS(1004), 1,
      sym_identifier,
    ACTIONS(1043), 1,
      anon_sym_in,
    STATE(472), 1,
      sym_let_item,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15432] = 4,
    ACTIONS(980), 1,
      sym_identifier,
    STATE(427), 1,
      sym_let_item,
    STATE(550), 1,
      sym_let_list,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15447] = 4,
    ACTIONS(837), 1,
      anon_sym_LBRACE,
    ACTIONS(839), 1,
      anon_sym_SEMI,
    STATE(311), 1,
      sym_multiclass_body,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15462] = 4,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(847), 1,
      anon_sym_SEMI,
    STATE(275), 1,
      sym_multiclass_body,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15477] = 3,
    ACTIONS(1045), 1,
      anon_sym_LBRACE,
    ACTIONS(1047), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15489] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1049), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15501] = 2,
    ACTIONS(1051), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15511] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1053), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15523] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1055), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15535] = 3,
    ACTIONS(1057), 1,
      anon_sym_EQ,
    ACTIONS(1059), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15547] = 2,
    ACTIONS(1061), 2,
      anon_sym_GT,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15557] = 3,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(526), 1,
      sym_foreach_iterator,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15569] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1065), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15581] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1067), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15593] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1069), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15605] = 3,
    ACTIONS(107), 1,
      anon_sym_DQUOTE,
    STATE(233), 1,
      sym_string,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15617] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1071), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15629] = 3,
    ACTIONS(1073), 1,
      anon_sym_LT,
    ACTIONS(1075), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15641] = 2,
    ACTIONS(1077), 2,
      anon_sym_GT,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15651] = 2,
    ACTIONS(1041), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15661] = 3,
    ACTIONS(980), 1,
      sym_identifier,
    STATE(472), 1,
      sym_let_item,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15673] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1079), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15685] = 2,
    ACTIONS(1081), 2,
      anon_sym_GT,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15695] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1083), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15707] = 2,
    ACTIONS(833), 2,
      anon_sym_GT,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15717] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1085), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15729] = 2,
    ACTIONS(1036), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15739] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1087), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15751] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1089), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15763] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1091), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15775] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1093), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15787] = 3,
    ACTIONS(1095), 1,
      anon_sym_DQUOTE,
    STATE(243), 1,
      sym_string,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15799] = 3,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(505), 1,
      sym_foreach_iterator,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15811] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1097), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15823] = 3,
    ACTIONS(1099), 1,
      anon_sym_LT,
    ACTIONS(1101), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15835] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1103), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15847] = 3,
    ACTIONS(63), 1,
      anon_sym_DQUOTE,
    STATE(302), 1,
      sym_string,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15859] = 3,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(520), 1,
      sym_foreach_iterator,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15871] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1105), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15883] = 2,
    ACTIONS(1011), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15893] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15905] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1109), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15917] = 3,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(559), 1,
      sym_foreach_iterator,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15929] = 2,
    ACTIONS(1111), 2,
      anon_sym_GT,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15939] = 3,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(561), 1,
      sym_foreach_iterator,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15951] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1113), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15963] = 3,
    ACTIONS(813), 1,
      anon_sym_POUND,
    ACTIONS(1115), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15975] = 3,
    ACTIONS(1063), 1,
      sym_identifier,
    STATE(552), 1,
      sym_foreach_iterator,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15987] = 3,
    ACTIONS(1117), 1,
      anon_sym_LT,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [15999] = 3,
    ACTIONS(1121), 1,
      anon_sym_EQ,
    ACTIONS(1123), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16011] = 2,
    ACTIONS(1125), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16020] = 2,
    ACTIONS(1127), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16029] = 2,
    ACTIONS(1129), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16038] = 2,
    ACTIONS(1131), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16047] = 2,
    ACTIONS(1133), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16056] = 2,
    ACTIONS(1135), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16065] = 2,
    ACTIONS(1137), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16074] = 2,
    ACTIONS(1139), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16083] = 2,
    ACTIONS(1141), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16092] = 2,
    ACTIONS(1143), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16101] = 2,
    ACTIONS(1145), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16110] = 2,
    ACTIONS(1147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16119] = 2,
    ACTIONS(1149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16128] = 2,
    ACTIONS(1151), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16137] = 2,
    ACTIONS(1153), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16146] = 2,
    ACTIONS(1155), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16155] = 2,
    ACTIONS(1157), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16164] = 2,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16173] = 2,
    ACTIONS(1161), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16182] = 2,
    ACTIONS(1163), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16191] = 2,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16200] = 2,
    ACTIONS(1167), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16209] = 2,
    ACTIONS(1169), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16218] = 2,
    ACTIONS(1155), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16227] = 2,
    ACTIONS(990), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16236] = 2,
    ACTIONS(929), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16245] = 2,
    ACTIONS(1143), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16254] = 2,
    ACTIONS(1171), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16263] = 2,
    ACTIONS(1173), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16272] = 2,
    ACTIONS(1175), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16281] = 2,
    ACTIONS(1177), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16290] = 2,
    ACTIONS(1179), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16299] = 2,
    ACTIONS(1181), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16308] = 2,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16317] = 2,
    ACTIONS(1185), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16326] = 2,
    ACTIONS(1187), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16335] = 2,
    ACTIONS(1189), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16344] = 2,
    ACTIONS(1191), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16353] = 2,
    ACTIONS(1193), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16362] = 2,
    ACTIONS(1195), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16371] = 2,
    ACTIONS(976), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16380] = 2,
    ACTIONS(998), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16389] = 2,
    ACTIONS(1197), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16398] = 2,
    ACTIONS(1199), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16407] = 2,
    ACTIONS(1201), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16416] = 2,
    ACTIONS(1203), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16425] = 2,
    ACTIONS(1205), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16434] = 2,
    ACTIONS(1207), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16443] = 2,
    ACTIONS(1209), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16452] = 2,
    ACTIONS(1211), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16461] = 2,
    ACTIONS(1213), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16470] = 2,
    ACTIONS(1215), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16479] = 2,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16488] = 2,
    ACTIONS(1219), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16497] = 2,
    ACTIONS(1221), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16506] = 2,
    ACTIONS(1223), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16515] = 2,
    ACTIONS(1225), 1,
      anon_sym_LT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16524] = 2,
    ACTIONS(1227), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16533] = 2,
    ACTIONS(1229), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16542] = 2,
    ACTIONS(1231), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16551] = 2,
    ACTIONS(1233), 1,
      sym_var,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16560] = 2,
    ACTIONS(1235), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16569] = 2,
    ACTIONS(1237), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16578] = 2,
    ACTIONS(947), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16587] = 2,
    ACTIONS(1239), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16596] = 2,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16605] = 2,
    ACTIONS(1243), 1,
      sym_integer,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16614] = 2,
    ACTIONS(1245), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16623] = 2,
    ACTIONS(1247), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16632] = 2,
    ACTIONS(1249), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16641] = 2,
    ACTIONS(1251), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16650] = 2,
    ACTIONS(1253), 1,
      anon_sym_LT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16659] = 2,
    ACTIONS(1255), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16668] = 2,
    ACTIONS(1257), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16677] = 2,
    ACTIONS(1259), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16686] = 2,
    ACTIONS(1261), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16695] = 2,
    ACTIONS(1263), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16704] = 2,
    ACTIONS(1265), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16713] = 2,
    ACTIONS(1267), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16722] = 2,
    ACTIONS(1269), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16731] = 2,
    ACTIONS(1271), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16740] = 2,
    ACTIONS(1273), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16749] = 2,
    ACTIONS(1275), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16758] = 2,
    ACTIONS(1277), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16767] = 2,
    ACTIONS(1279), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16776] = 2,
    ACTIONS(1281), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16785] = 2,
    ACTIONS(1283), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16794] = 2,
    ACTIONS(1285), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16803] = 2,
    ACTIONS(1287), 1,
      anon_sym_GT,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16812] = 2,
    ACTIONS(1289), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16821] = 2,
    ACTIONS(1291), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
  [16830] = 2,
    ACTIONS(1293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_multiline_comment,
      sym_preprocessor_directive,
      sym_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 113,
  [SMALL_STATE(4)] = 226,
  [SMALL_STATE(5)] = 339,
  [SMALL_STATE(6)] = 397,
  [SMALL_STATE(7)] = 473,
  [SMALL_STATE(8)] = 547,
  [SMALL_STATE(9)] = 587,
  [SMALL_STATE(10)] = 627,
  [SMALL_STATE(11)] = 702,
  [SMALL_STATE(12)] = 777,
  [SMALL_STATE(13)] = 852,
  [SMALL_STATE(14)] = 929,
  [SMALL_STATE(15)] = 1006,
  [SMALL_STATE(16)] = 1083,
  [SMALL_STATE(17)] = 1154,
  [SMALL_STATE(18)] = 1228,
  [SMALL_STATE(19)] = 1302,
  [SMALL_STATE(20)] = 1373,
  [SMALL_STATE(21)] = 1444,
  [SMALL_STATE(22)] = 1511,
  [SMALL_STATE(23)] = 1582,
  [SMALL_STATE(24)] = 1649,
  [SMALL_STATE(25)] = 1720,
  [SMALL_STATE(26)] = 1791,
  [SMALL_STATE(27)] = 1862,
  [SMALL_STATE(28)] = 1931,
  [SMALL_STATE(29)] = 2002,
  [SMALL_STATE(30)] = 2073,
  [SMALL_STATE(31)] = 2141,
  [SMALL_STATE(32)] = 2209,
  [SMALL_STATE(33)] = 2277,
  [SMALL_STATE(34)] = 2345,
  [SMALL_STATE(35)] = 2413,
  [SMALL_STATE(36)] = 2481,
  [SMALL_STATE(37)] = 2549,
  [SMALL_STATE(38)] = 2617,
  [SMALL_STATE(39)] = 2685,
  [SMALL_STATE(40)] = 2753,
  [SMALL_STATE(41)] = 2821,
  [SMALL_STATE(42)] = 2889,
  [SMALL_STATE(43)] = 2957,
  [SMALL_STATE(44)] = 3025,
  [SMALL_STATE(45)] = 3093,
  [SMALL_STATE(46)] = 3161,
  [SMALL_STATE(47)] = 3229,
  [SMALL_STATE(48)] = 3290,
  [SMALL_STATE(49)] = 3355,
  [SMALL_STATE(50)] = 3420,
  [SMALL_STATE(51)] = 3479,
  [SMALL_STATE(52)] = 3538,
  [SMALL_STATE(53)] = 3599,
  [SMALL_STATE(54)] = 3664,
  [SMALL_STATE(55)] = 3723,
  [SMALL_STATE(56)] = 3784,
  [SMALL_STATE(57)] = 3843,
  [SMALL_STATE(58)] = 3908,
  [SMALL_STATE(59)] = 3973,
  [SMALL_STATE(60)] = 4038,
  [SMALL_STATE(61)] = 4097,
  [SMALL_STATE(62)] = 4158,
  [SMALL_STATE(63)] = 4219,
  [SMALL_STATE(64)] = 4278,
  [SMALL_STATE(65)] = 4337,
  [SMALL_STATE(66)] = 4396,
  [SMALL_STATE(67)] = 4455,
  [SMALL_STATE(68)] = 4514,
  [SMALL_STATE(69)] = 4573,
  [SMALL_STATE(70)] = 4634,
  [SMALL_STATE(71)] = 4695,
  [SMALL_STATE(72)] = 4756,
  [SMALL_STATE(73)] = 4821,
  [SMALL_STATE(74)] = 4886,
  [SMALL_STATE(75)] = 4951,
  [SMALL_STATE(76)] = 5012,
  [SMALL_STATE(77)] = 5073,
  [SMALL_STATE(78)] = 5134,
  [SMALL_STATE(79)] = 5193,
  [SMALL_STATE(80)] = 5252,
  [SMALL_STATE(81)] = 5311,
  [SMALL_STATE(82)] = 5370,
  [SMALL_STATE(83)] = 5429,
  [SMALL_STATE(84)] = 5490,
  [SMALL_STATE(85)] = 5549,
  [SMALL_STATE(86)] = 5610,
  [SMALL_STATE(87)] = 5669,
  [SMALL_STATE(88)] = 5730,
  [SMALL_STATE(89)] = 5795,
  [SMALL_STATE(90)] = 5860,
  [SMALL_STATE(91)] = 5925,
  [SMALL_STATE(92)] = 5990,
  [SMALL_STATE(93)] = 6055,
  [SMALL_STATE(94)] = 6120,
  [SMALL_STATE(95)] = 6181,
  [SMALL_STATE(96)] = 6242,
  [SMALL_STATE(97)] = 6303,
  [SMALL_STATE(98)] = 6362,
  [SMALL_STATE(99)] = 6424,
  [SMALL_STATE(100)] = 6482,
  [SMALL_STATE(101)] = 6544,
  [SMALL_STATE(102)] = 6578,
  [SMALL_STATE(103)] = 6612,
  [SMALL_STATE(104)] = 6674,
  [SMALL_STATE(105)] = 6732,
  [SMALL_STATE(106)] = 6794,
  [SMALL_STATE(107)] = 6856,
  [SMALL_STATE(108)] = 6918,
  [SMALL_STATE(109)] = 6980,
  [SMALL_STATE(110)] = 7042,
  [SMALL_STATE(111)] = 7104,
  [SMALL_STATE(112)] = 7166,
  [SMALL_STATE(113)] = 7224,
  [SMALL_STATE(114)] = 7286,
  [SMALL_STATE(115)] = 7348,
  [SMALL_STATE(116)] = 7406,
  [SMALL_STATE(117)] = 7468,
  [SMALL_STATE(118)] = 7530,
  [SMALL_STATE(119)] = 7592,
  [SMALL_STATE(120)] = 7654,
  [SMALL_STATE(121)] = 7716,
  [SMALL_STATE(122)] = 7778,
  [SMALL_STATE(123)] = 7840,
  [SMALL_STATE(124)] = 7902,
  [SMALL_STATE(125)] = 7960,
  [SMALL_STATE(126)] = 8022,
  [SMALL_STATE(127)] = 8084,
  [SMALL_STATE(128)] = 8146,
  [SMALL_STATE(129)] = 8208,
  [SMALL_STATE(130)] = 8270,
  [SMALL_STATE(131)] = 8328,
  [SMALL_STATE(132)] = 8390,
  [SMALL_STATE(133)] = 8447,
  [SMALL_STATE(134)] = 8504,
  [SMALL_STATE(135)] = 8561,
  [SMALL_STATE(136)] = 8618,
  [SMALL_STATE(137)] = 8675,
  [SMALL_STATE(138)] = 8732,
  [SMALL_STATE(139)] = 8789,
  [SMALL_STATE(140)] = 8821,
  [SMALL_STATE(141)] = 8854,
  [SMALL_STATE(142)] = 8887,
  [SMALL_STATE(143)] = 8920,
  [SMALL_STATE(144)] = 8957,
  [SMALL_STATE(145)] = 8990,
  [SMALL_STATE(146)] = 9023,
  [SMALL_STATE(147)] = 9055,
  [SMALL_STATE(148)] = 9085,
  [SMALL_STATE(149)] = 9115,
  [SMALL_STATE(150)] = 9143,
  [SMALL_STATE(151)] = 9175,
  [SMALL_STATE(152)] = 9207,
  [SMALL_STATE(153)] = 9237,
  [SMALL_STATE(154)] = 9272,
  [SMALL_STATE(155)] = 9299,
  [SMALL_STATE(156)] = 9334,
  [SMALL_STATE(157)] = 9361,
  [SMALL_STATE(158)] = 9388,
  [SMALL_STATE(159)] = 9431,
  [SMALL_STATE(160)] = 9466,
  [SMALL_STATE(161)] = 9493,
  [SMALL_STATE(162)] = 9520,
  [SMALL_STATE(163)] = 9547,
  [SMALL_STATE(164)] = 9574,
  [SMALL_STATE(165)] = 9617,
  [SMALL_STATE(166)] = 9644,
  [SMALL_STATE(167)] = 9671,
  [SMALL_STATE(168)] = 9714,
  [SMALL_STATE(169)] = 9741,
  [SMALL_STATE(170)] = 9768,
  [SMALL_STATE(171)] = 9795,
  [SMALL_STATE(172)] = 9822,
  [SMALL_STATE(173)] = 9849,
  [SMALL_STATE(174)] = 9876,
  [SMALL_STATE(175)] = 9903,
  [SMALL_STATE(176)] = 9930,
  [SMALL_STATE(177)] = 9973,
  [SMALL_STATE(178)] = 10001,
  [SMALL_STATE(179)] = 10041,
  [SMALL_STATE(180)] = 10081,
  [SMALL_STATE(181)] = 10109,
  [SMALL_STATE(182)] = 10149,
  [SMALL_STATE(183)] = 10179,
  [SMALL_STATE(184)] = 10207,
  [SMALL_STATE(185)] = 10235,
  [SMALL_STATE(186)] = 10260,
  [SMALL_STATE(187)] = 10285,
  [SMALL_STATE(188)] = 10310,
  [SMALL_STATE(189)] = 10335,
  [SMALL_STATE(190)] = 10360,
  [SMALL_STATE(191)] = 10385,
  [SMALL_STATE(192)] = 10410,
  [SMALL_STATE(193)] = 10435,
  [SMALL_STATE(194)] = 10460,
  [SMALL_STATE(195)] = 10485,
  [SMALL_STATE(196)] = 10510,
  [SMALL_STATE(197)] = 10535,
  [SMALL_STATE(198)] = 10560,
  [SMALL_STATE(199)] = 10585,
  [SMALL_STATE(200)] = 10610,
  [SMALL_STATE(201)] = 10635,
  [SMALL_STATE(202)] = 10660,
  [SMALL_STATE(203)] = 10684,
  [SMALL_STATE(204)] = 10722,
  [SMALL_STATE(205)] = 10746,
  [SMALL_STATE(206)] = 10770,
  [SMALL_STATE(207)] = 10793,
  [SMALL_STATE(208)] = 10816,
  [SMALL_STATE(209)] = 10839,
  [SMALL_STATE(210)] = 10862,
  [SMALL_STATE(211)] = 10885,
  [SMALL_STATE(212)] = 10908,
  [SMALL_STATE(213)] = 10931,
  [SMALL_STATE(214)] = 10954,
  [SMALL_STATE(215)] = 10989,
  [SMALL_STATE(216)] = 11012,
  [SMALL_STATE(217)] = 11035,
  [SMALL_STATE(218)] = 11058,
  [SMALL_STATE(219)] = 11081,
  [SMALL_STATE(220)] = 11104,
  [SMALL_STATE(221)] = 11127,
  [SMALL_STATE(222)] = 11150,
  [SMALL_STATE(223)] = 11173,
  [SMALL_STATE(224)] = 11196,
  [SMALL_STATE(225)] = 11219,
  [SMALL_STATE(226)] = 11242,
  [SMALL_STATE(227)] = 11265,
  [SMALL_STATE(228)] = 11288,
  [SMALL_STATE(229)] = 11311,
  [SMALL_STATE(230)] = 11334,
  [SMALL_STATE(231)] = 11357,
  [SMALL_STATE(232)] = 11380,
  [SMALL_STATE(233)] = 11403,
  [SMALL_STATE(234)] = 11426,
  [SMALL_STATE(235)] = 11449,
  [SMALL_STATE(236)] = 11472,
  [SMALL_STATE(237)] = 11495,
  [SMALL_STATE(238)] = 11518,
  [SMALL_STATE(239)] = 11541,
  [SMALL_STATE(240)] = 11564,
  [SMALL_STATE(241)] = 11587,
  [SMALL_STATE(242)] = 11610,
  [SMALL_STATE(243)] = 11633,
  [SMALL_STATE(244)] = 11656,
  [SMALL_STATE(245)] = 11679,
  [SMALL_STATE(246)] = 11702,
  [SMALL_STATE(247)] = 11725,
  [SMALL_STATE(248)] = 11748,
  [SMALL_STATE(249)] = 11771,
  [SMALL_STATE(250)] = 11794,
  [SMALL_STATE(251)] = 11817,
  [SMALL_STATE(252)] = 11840,
  [SMALL_STATE(253)] = 11863,
  [SMALL_STATE(254)] = 11886,
  [SMALL_STATE(255)] = 11909,
  [SMALL_STATE(256)] = 11932,
  [SMALL_STATE(257)] = 11955,
  [SMALL_STATE(258)] = 11978,
  [SMALL_STATE(259)] = 12001,
  [SMALL_STATE(260)] = 12024,
  [SMALL_STATE(261)] = 12047,
  [SMALL_STATE(262)] = 12070,
  [SMALL_STATE(263)] = 12093,
  [SMALL_STATE(264)] = 12116,
  [SMALL_STATE(265)] = 12139,
  [SMALL_STATE(266)] = 12162,
  [SMALL_STATE(267)] = 12185,
  [SMALL_STATE(268)] = 12208,
  [SMALL_STATE(269)] = 12231,
  [SMALL_STATE(270)] = 12254,
  [SMALL_STATE(271)] = 12277,
  [SMALL_STATE(272)] = 12300,
  [SMALL_STATE(273)] = 12323,
  [SMALL_STATE(274)] = 12348,
  [SMALL_STATE(275)] = 12371,
  [SMALL_STATE(276)] = 12394,
  [SMALL_STATE(277)] = 12417,
  [SMALL_STATE(278)] = 12440,
  [SMALL_STATE(279)] = 12463,
  [SMALL_STATE(280)] = 12486,
  [SMALL_STATE(281)] = 12511,
  [SMALL_STATE(282)] = 12546,
  [SMALL_STATE(283)] = 12569,
  [SMALL_STATE(284)] = 12592,
  [SMALL_STATE(285)] = 12615,
  [SMALL_STATE(286)] = 12638,
  [SMALL_STATE(287)] = 12670,
  [SMALL_STATE(288)] = 12702,
  [SMALL_STATE(289)] = 12731,
  [SMALL_STATE(290)] = 12760,
  [SMALL_STATE(291)] = 12789,
  [SMALL_STATE(292)] = 12818,
  [SMALL_STATE(293)] = 12847,
  [SMALL_STATE(294)] = 12876,
  [SMALL_STATE(295)] = 12905,
  [SMALL_STATE(296)] = 12934,
  [SMALL_STATE(297)] = 12963,
  [SMALL_STATE(298)] = 12992,
  [SMALL_STATE(299)] = 13012,
  [SMALL_STATE(300)] = 13031,
  [SMALL_STATE(301)] = 13050,
  [SMALL_STATE(302)] = 13069,
  [SMALL_STATE(303)] = 13088,
  [SMALL_STATE(304)] = 13107,
  [SMALL_STATE(305)] = 13126,
  [SMALL_STATE(306)] = 13145,
  [SMALL_STATE(307)] = 13164,
  [SMALL_STATE(308)] = 13183,
  [SMALL_STATE(309)] = 13202,
  [SMALL_STATE(310)] = 13221,
  [SMALL_STATE(311)] = 13240,
  [SMALL_STATE(312)] = 13259,
  [SMALL_STATE(313)] = 13278,
  [SMALL_STATE(314)] = 13297,
  [SMALL_STATE(315)] = 13316,
  [SMALL_STATE(316)] = 13335,
  [SMALL_STATE(317)] = 13354,
  [SMALL_STATE(318)] = 13373,
  [SMALL_STATE(319)] = 13392,
  [SMALL_STATE(320)] = 13411,
  [SMALL_STATE(321)] = 13430,
  [SMALL_STATE(322)] = 13449,
  [SMALL_STATE(323)] = 13468,
  [SMALL_STATE(324)] = 13487,
  [SMALL_STATE(325)] = 13506,
  [SMALL_STATE(326)] = 13525,
  [SMALL_STATE(327)] = 13544,
  [SMALL_STATE(328)] = 13565,
  [SMALL_STATE(329)] = 13584,
  [SMALL_STATE(330)] = 13603,
  [SMALL_STATE(331)] = 13622,
  [SMALL_STATE(332)] = 13641,
  [SMALL_STATE(333)] = 13659,
  [SMALL_STATE(334)] = 13677,
  [SMALL_STATE(335)] = 13707,
  [SMALL_STATE(336)] = 13731,
  [SMALL_STATE(337)] = 13749,
  [SMALL_STATE(338)] = 13779,
  [SMALL_STATE(339)] = 13803,
  [SMALL_STATE(340)] = 13833,
  [SMALL_STATE(341)] = 13855,
  [SMALL_STATE(342)] = 13882,
  [SMALL_STATE(343)] = 13909,
  [SMALL_STATE(344)] = 13936,
  [SMALL_STATE(345)] = 13963,
  [SMALL_STATE(346)] = 13982,
  [SMALL_STATE(347)] = 14009,
  [SMALL_STATE(348)] = 14036,
  [SMALL_STATE(349)] = 14054,
  [SMALL_STATE(350)] = 14076,
  [SMALL_STATE(351)] = 14098,
  [SMALL_STATE(352)] = 14120,
  [SMALL_STATE(353)] = 14144,
  [SMALL_STATE(354)] = 14166,
  [SMALL_STATE(355)] = 14188,
  [SMALL_STATE(356)] = 14208,
  [SMALL_STATE(357)] = 14232,
  [SMALL_STATE(358)] = 14248,
  [SMALL_STATE(359)] = 14268,
  [SMALL_STATE(360)] = 14290,
  [SMALL_STATE(361)] = 14312,
  [SMALL_STATE(362)] = 14336,
  [SMALL_STATE(363)] = 14352,
  [SMALL_STATE(364)] = 14369,
  [SMALL_STATE(365)] = 14386,
  [SMALL_STATE(366)] = 14403,
  [SMALL_STATE(367)] = 14424,
  [SMALL_STATE(368)] = 14441,
  [SMALL_STATE(369)] = 14462,
  [SMALL_STATE(370)] = 14483,
  [SMALL_STATE(371)] = 14502,
  [SMALL_STATE(372)] = 14514,
  [SMALL_STATE(373)] = 14530,
  [SMALL_STATE(374)] = 14548,
  [SMALL_STATE(375)] = 14564,
  [SMALL_STATE(376)] = 14582,
  [SMALL_STATE(377)] = 14600,
  [SMALL_STATE(378)] = 14616,
  [SMALL_STATE(379)] = 14634,
  [SMALL_STATE(380)] = 14650,
  [SMALL_STATE(381)] = 14666,
  [SMALL_STATE(382)] = 14682,
  [SMALL_STATE(383)] = 14698,
  [SMALL_STATE(384)] = 14716,
  [SMALL_STATE(385)] = 14732,
  [SMALL_STATE(386)] = 14748,
  [SMALL_STATE(387)] = 14766,
  [SMALL_STATE(388)] = 14780,
  [SMALL_STATE(389)] = 14796,
  [SMALL_STATE(390)] = 14810,
  [SMALL_STATE(391)] = 14828,
  [SMALL_STATE(392)] = 14844,
  [SMALL_STATE(393)] = 14859,
  [SMALL_STATE(394)] = 14872,
  [SMALL_STATE(395)] = 14885,
  [SMALL_STATE(396)] = 14900,
  [SMALL_STATE(397)] = 14915,
  [SMALL_STATE(398)] = 14930,
  [SMALL_STATE(399)] = 14941,
  [SMALL_STATE(400)] = 14952,
  [SMALL_STATE(401)] = 14967,
  [SMALL_STATE(402)] = 14982,
  [SMALL_STATE(403)] = 14997,
  [SMALL_STATE(404)] = 15012,
  [SMALL_STATE(405)] = 15027,
  [SMALL_STATE(406)] = 15040,
  [SMALL_STATE(407)] = 15051,
  [SMALL_STATE(408)] = 15066,
  [SMALL_STATE(409)] = 15081,
  [SMALL_STATE(410)] = 15096,
  [SMALL_STATE(411)] = 15111,
  [SMALL_STATE(412)] = 15126,
  [SMALL_STATE(413)] = 15137,
  [SMALL_STATE(414)] = 15152,
  [SMALL_STATE(415)] = 15167,
  [SMALL_STATE(416)] = 15182,
  [SMALL_STATE(417)] = 15193,
  [SMALL_STATE(418)] = 15204,
  [SMALL_STATE(419)] = 15215,
  [SMALL_STATE(420)] = 15230,
  [SMALL_STATE(421)] = 15243,
  [SMALL_STATE(422)] = 15254,
  [SMALL_STATE(423)] = 15267,
  [SMALL_STATE(424)] = 15282,
  [SMALL_STATE(425)] = 15297,
  [SMALL_STATE(426)] = 15312,
  [SMALL_STATE(427)] = 15327,
  [SMALL_STATE(428)] = 15342,
  [SMALL_STATE(429)] = 15357,
  [SMALL_STATE(430)] = 15372,
  [SMALL_STATE(431)] = 15387,
  [SMALL_STATE(432)] = 15402,
  [SMALL_STATE(433)] = 15417,
  [SMALL_STATE(434)] = 15432,
  [SMALL_STATE(435)] = 15447,
  [SMALL_STATE(436)] = 15462,
  [SMALL_STATE(437)] = 15477,
  [SMALL_STATE(438)] = 15489,
  [SMALL_STATE(439)] = 15501,
  [SMALL_STATE(440)] = 15511,
  [SMALL_STATE(441)] = 15523,
  [SMALL_STATE(442)] = 15535,
  [SMALL_STATE(443)] = 15547,
  [SMALL_STATE(444)] = 15557,
  [SMALL_STATE(445)] = 15569,
  [SMALL_STATE(446)] = 15581,
  [SMALL_STATE(447)] = 15593,
  [SMALL_STATE(448)] = 15605,
  [SMALL_STATE(449)] = 15617,
  [SMALL_STATE(450)] = 15629,
  [SMALL_STATE(451)] = 15641,
  [SMALL_STATE(452)] = 15651,
  [SMALL_STATE(453)] = 15661,
  [SMALL_STATE(454)] = 15673,
  [SMALL_STATE(455)] = 15685,
  [SMALL_STATE(456)] = 15695,
  [SMALL_STATE(457)] = 15707,
  [SMALL_STATE(458)] = 15717,
  [SMALL_STATE(459)] = 15729,
  [SMALL_STATE(460)] = 15739,
  [SMALL_STATE(461)] = 15751,
  [SMALL_STATE(462)] = 15763,
  [SMALL_STATE(463)] = 15775,
  [SMALL_STATE(464)] = 15787,
  [SMALL_STATE(465)] = 15799,
  [SMALL_STATE(466)] = 15811,
  [SMALL_STATE(467)] = 15823,
  [SMALL_STATE(468)] = 15835,
  [SMALL_STATE(469)] = 15847,
  [SMALL_STATE(470)] = 15859,
  [SMALL_STATE(471)] = 15871,
  [SMALL_STATE(472)] = 15883,
  [SMALL_STATE(473)] = 15893,
  [SMALL_STATE(474)] = 15905,
  [SMALL_STATE(475)] = 15917,
  [SMALL_STATE(476)] = 15929,
  [SMALL_STATE(477)] = 15939,
  [SMALL_STATE(478)] = 15951,
  [SMALL_STATE(479)] = 15963,
  [SMALL_STATE(480)] = 15975,
  [SMALL_STATE(481)] = 15987,
  [SMALL_STATE(482)] = 15999,
  [SMALL_STATE(483)] = 16011,
  [SMALL_STATE(484)] = 16020,
  [SMALL_STATE(485)] = 16029,
  [SMALL_STATE(486)] = 16038,
  [SMALL_STATE(487)] = 16047,
  [SMALL_STATE(488)] = 16056,
  [SMALL_STATE(489)] = 16065,
  [SMALL_STATE(490)] = 16074,
  [SMALL_STATE(491)] = 16083,
  [SMALL_STATE(492)] = 16092,
  [SMALL_STATE(493)] = 16101,
  [SMALL_STATE(494)] = 16110,
  [SMALL_STATE(495)] = 16119,
  [SMALL_STATE(496)] = 16128,
  [SMALL_STATE(497)] = 16137,
  [SMALL_STATE(498)] = 16146,
  [SMALL_STATE(499)] = 16155,
  [SMALL_STATE(500)] = 16164,
  [SMALL_STATE(501)] = 16173,
  [SMALL_STATE(502)] = 16182,
  [SMALL_STATE(503)] = 16191,
  [SMALL_STATE(504)] = 16200,
  [SMALL_STATE(505)] = 16209,
  [SMALL_STATE(506)] = 16218,
  [SMALL_STATE(507)] = 16227,
  [SMALL_STATE(508)] = 16236,
  [SMALL_STATE(509)] = 16245,
  [SMALL_STATE(510)] = 16254,
  [SMALL_STATE(511)] = 16263,
  [SMALL_STATE(512)] = 16272,
  [SMALL_STATE(513)] = 16281,
  [SMALL_STATE(514)] = 16290,
  [SMALL_STATE(515)] = 16299,
  [SMALL_STATE(516)] = 16308,
  [SMALL_STATE(517)] = 16317,
  [SMALL_STATE(518)] = 16326,
  [SMALL_STATE(519)] = 16335,
  [SMALL_STATE(520)] = 16344,
  [SMALL_STATE(521)] = 16353,
  [SMALL_STATE(522)] = 16362,
  [SMALL_STATE(523)] = 16371,
  [SMALL_STATE(524)] = 16380,
  [SMALL_STATE(525)] = 16389,
  [SMALL_STATE(526)] = 16398,
  [SMALL_STATE(527)] = 16407,
  [SMALL_STATE(528)] = 16416,
  [SMALL_STATE(529)] = 16425,
  [SMALL_STATE(530)] = 16434,
  [SMALL_STATE(531)] = 16443,
  [SMALL_STATE(532)] = 16452,
  [SMALL_STATE(533)] = 16461,
  [SMALL_STATE(534)] = 16470,
  [SMALL_STATE(535)] = 16479,
  [SMALL_STATE(536)] = 16488,
  [SMALL_STATE(537)] = 16497,
  [SMALL_STATE(538)] = 16506,
  [SMALL_STATE(539)] = 16515,
  [SMALL_STATE(540)] = 16524,
  [SMALL_STATE(541)] = 16533,
  [SMALL_STATE(542)] = 16542,
  [SMALL_STATE(543)] = 16551,
  [SMALL_STATE(544)] = 16560,
  [SMALL_STATE(545)] = 16569,
  [SMALL_STATE(546)] = 16578,
  [SMALL_STATE(547)] = 16587,
  [SMALL_STATE(548)] = 16596,
  [SMALL_STATE(549)] = 16605,
  [SMALL_STATE(550)] = 16614,
  [SMALL_STATE(551)] = 16623,
  [SMALL_STATE(552)] = 16632,
  [SMALL_STATE(553)] = 16641,
  [SMALL_STATE(554)] = 16650,
  [SMALL_STATE(555)] = 16659,
  [SMALL_STATE(556)] = 16668,
  [SMALL_STATE(557)] = 16677,
  [SMALL_STATE(558)] = 16686,
  [SMALL_STATE(559)] = 16695,
  [SMALL_STATE(560)] = 16704,
  [SMALL_STATE(561)] = 16713,
  [SMALL_STATE(562)] = 16722,
  [SMALL_STATE(563)] = 16731,
  [SMALL_STATE(564)] = 16740,
  [SMALL_STATE(565)] = 16749,
  [SMALL_STATE(566)] = 16758,
  [SMALL_STATE(567)] = 16767,
  [SMALL_STATE(568)] = 16776,
  [SMALL_STATE(569)] = 16785,
  [SMALL_STATE(570)] = 16794,
  [SMALL_STATE(571)] = 16803,
  [SMALL_STATE(572)] = 16812,
  [SMALL_STATE(573)] = 16821,
  [SMALL_STATE(574)] = 16830,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tablegen_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [79] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paste_value, 2, 0, 0),
  [81] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paste_value, 2, 0, 0),
  [83] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [85] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [87] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [89] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dag_arg_list, 1, 0, 0),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(147),
  [116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(89),
  [119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(40),
  [125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(165),
  [128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(45),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0),
  [133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5),
  [136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(165),
  [139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(353),
  [142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(169),
  [145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(204),
  [148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dag_arg_list, 2, 0, 0),
  [152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_list, 2, 0, 0),
  [174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_list, 3, 0, 0),
  [176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dag_arg_list, 3, 0, 0),
  [178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tablegen_file, 1, 0, 0),
  [266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(448),
  [277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(499),
  [282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(428),
  [285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(566),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(15),
  [291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(500),
  [294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(26),
  [297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(297),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(470),
  [303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(108),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0),
  [335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(464),
  [338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(70),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(572),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(403),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(487),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(14),
  [353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(541),
  [356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(25),
  [359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(444),
  [365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(109),
  [368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tablegen_file_repeat1, 2, 0, 0), SHIFT_REPEAT(106),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2, 0, 0), SHIFT_REPEAT(457),
  [416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_body_repeat1, 2, 0, 0),
  [418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2, 0, 0), SHIFT_REPEAT(286),
  [421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2, 0, 0), SHIFT_REPEAT(527),
  [424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2, 0, 0), SHIFT_REPEAT(530),
  [427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2, 0, 0), SHIFT_REPEAT(547),
  [430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2, 0, 0), SHIFT_REPEAT(129),
  [433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2, 0, 0), SHIFT_REPEAT(455),
  [436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2, 0, 0), SHIFT_REPEAT(539),
  [439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2, 0, 0), SHIFT_REPEAT(554),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 1, 0, 0),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1, 0, 0),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_value, 1, 0, 0),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_value, 1, 0, 0),
  [456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0),
  [464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(46),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0),
  [469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(32),
  [472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(567),
  [475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(353),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 2, 0, 0),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 2, 0, 0),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_initializer, 3, 0, 0),
  [490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_initializer, 3, 0, 0),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert, 5, 0, 0),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert, 5, 0, 0),
  [498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(360),
  [501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_initializer, 2, 0, 0),
  [503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_initializer, 2, 0, 0),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 4, 0, 0),
  [515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 4, 0, 0),
  [517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_initializer, 5, 0, 0),
  [519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_initializer, 5, 0, 0),
  [521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_record, 5, 0, 0),
  [523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_record, 5, 0, 0),
  [525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multiclass_body_repeat1, 2, 0, 0),
  [527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiclass_body_repeat1, 2, 0, 0), SHIFT_REPEAT(426),
  [530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiclass_body_repeat1, 2, 0, 0), SHIFT_REPEAT(548),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_multiclass_body_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiclass_body_repeat1, 2, 0, 0), SHIFT_REPEAT(19),
  [539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiclass_body_repeat1, 2, 0, 0), SHIFT_REPEAT(465),
  [542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiclass_body_repeat1, 2, 0, 0), SHIFT_REPEAT(123),
  [545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiclass_body_repeat1, 2, 0, 0), SHIFT_REPEAT(129),
  [548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(44),
  [554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(537),
  [557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 5, 0, 0),
  [559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 5, 0, 0),
  [561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_initializer, 6, 0, 0),
  [563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_initializer, 6, 0, 0),
  [565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 6, 0, 0),
  [567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 6, 0, 0),
  [569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 7, 0, 0),
  [571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 7, 0, 0),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence, 3, 0, 0),
  [577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence, 3, 0, 0),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_suffix, 2, 0, 0),
  [583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_suffix, 2, 0, 0),
  [585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0),
  [587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dag_initializer, 3, 0, 0),
  [591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dag_initializer, 3, 0, 0),
  [593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_record, 3, 0, 0),
  [595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_record, 3, 0, 0),
  [597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 3, 0, 0),
  [599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 3, 0, 0),
  [601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dag_initializer, 4, 0, 0),
  [603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dag_initializer, 4, 0, 0),
  [605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_record, 4, 0, 0),
  [607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_record, 4, 0, 0),
  [609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_suffix, 3, 0, 0),
  [611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_suffix, 3, 0, 0),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dag_arg, 1, 0, 0),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dag_arg, 1, 0, 0),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paste_value, 3, 0, 0),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paste_value, 3, 0, 0),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dag_arg_list_repeat1, 2, 0, 0),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dag_arg, 3, 0, 0),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dag_arg, 3, 0, 0),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def, 2, 0, 0),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def, 2, 0, 0),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 2),
  [649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 2),
  [651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_body_item, 1, 0, 0),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body_item, 1, 0, 0),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiclass_body, 3, 0, 0),
  [657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiclass_body, 3, 0, 0),
  [659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiclass, 5, 0, 3),
  [661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiclass, 5, 0, 3),
  [663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 1, 0, 0),
  [669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_body, 1, 0, 0),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 6, 0, 0),
  [675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let, 6, 0, 0),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 4, 0, 0),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 4, 0, 0),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_body, 2, 0, 0),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_body, 2, 0, 0),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def, 3, 0, 3),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def, 3, 0, 3),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defset, 6, 0, 5),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defset, 6, 0, 5),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 6, 0, 0),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 6, 0, 0),
  [705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 5, 0, 0),
  [707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 5, 0, 0),
  [709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_instruction, 5, 0, 0),
  [711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_instruction, 5, 0, 0),
  [713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def_var, 5, 0, 3),
  [715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def_var, 5, 0, 3),
  [717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_body, 1, 0, 0),
  [719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_body, 1, 0, 0),
  [721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defset, 7, 0, 5),
  [723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defset, 7, 0, 5),
  [725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 6, 0, 0),
  [727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 6, 0, 0),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiclass_body, 1, 0, 0),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiclass_body, 1, 0, 0),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiclass, 3, 0, 3),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiclass, 3, 0, 3),
  [737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_instruction, 8, 0, 0),
  [739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_instruction, 8, 0, 0),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_directive, 2, 0, 0),
  [743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_directive, 2, 0, 0),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defm, 3, 0, 0),
  [747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defm, 3, 0, 0),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defm, 3, 0, 3),
  [751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defm, 3, 0, 3),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 4),
  [755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 4),
  [757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiclass, 4, 0, 3),
  [759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiclass, 4, 0, 3),
  [761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 4, 0, 0),
  [763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let, 4, 0, 0),
  [765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 2, 0, 0),
  [767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_body, 2, 0, 0),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defm, 2, 0, 0),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defm, 2, 0, 0),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 3, 0, 0),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_body, 3, 0, 0),
  [777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defm, 4, 0, 3),
  [779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defm, 4, 0, 3),
  [781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1, 0, 0),
  [783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1, 0, 0),
  [785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach, 4, 0, 0),
  [787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach, 4, 0, 0),
  [789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 4, 0, 0),
  [791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 4, 0, 0),
  [793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 5, 0, 0),
  [795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let, 5, 0, 0),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defvar, 5, 0, 0),
  [799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defvar, 5, 0, 0),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 3, 0, 0),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 3, 0, 0),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiclass_statement, 1, 0, 0),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiclass_statement, 1, 0, 0),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 1),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_piece, 1, 0, 0),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parent_class_list_repeat1, 2, 0, 0),
  [855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parent_class_list_repeat1, 2, 0, 0), SHIFT_REPEAT(110),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(351),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(351),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_piece, 3, 0, 0),
  [890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_list, 1, 0, 0),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_list, 1, 0, 0),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_list, 2, 0, 0),
  [910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_range_list_repeat1, 2, 0, 0),
  [912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_range_list_repeat1, 2, 0, 0), SHIFT_REPEAT(73),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parent_class_list, 2, 0, 0),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parent_class_list, 5, 0, 0),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parent_class_list, 6, 0, 0),
  [937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parent_class_list, 3, 0, 0),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parent_class_list, 7, 0, 0),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parent_class_list, 4, 0, 0),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parent_class_list_repeat2, 2, 0, 0),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parent_class_list_repeat2, 2, 0, 0), SHIFT_REPEAT(516),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parent_class_list, 8, 0, 0),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_list, 2, 0, 0),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_arg, 4, 0, 0),
  [966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_item, 6, 0, 0),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parent_class_list_repeat2, 4, 0, 0),
  [972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_args, 2, 0, 0),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_item, 3, 0, 0),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parent_class_list_repeat2, 5, 0, 0),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_args, 5, 0, 0),
  [1004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_list, 3, 0, 0),
  [1008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_list_repeat1, 2, 0, 0), SHIFT_REPEAT(453),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_let_list_repeat1, 2, 0, 0),
  [1013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parent_class_list_repeat2, 6, 0, 0),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parent_class_list_repeat2, 7, 0, 0),
  [1017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_args, 3, 0, 0),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_arg, 2, 0, 0),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_args, 4, 0, 0),
  [1027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cond_clause, 3, 0, 0),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_list, 1, 0, 0),
  [1033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operator_repeat1, 2, 0, 0), SHIFT_REPEAT(91),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operator_repeat1, 2, 0, 0),
  [1038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_args_repeat1, 2, 0, 0), SHIFT_REPEAT(287),
  [1041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_args_repeat1, 2, 0, 0),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_list, 2, 0, 0),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bang_operator, 2, 0, 0),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bits_type, 4, 0, 0),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1, 0, 0),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_type, 4, 0, 0),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_iterator, 3, 0, 0),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cond_operator, 2, 0, 0),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1163] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_iterator, 5, 0, 0),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_multiline_comment = 0,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_multiline_comment] = sym_multiline_comment,
};

static const bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_multiline_comment] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_tablegen_external_scanner_create(void);
void tree_sitter_tablegen_external_scanner_destroy(void *);
bool tree_sitter_tablegen_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tablegen_external_scanner_serialize(void *, char *);
void tree_sitter_tablegen_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_tablegen(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_tablegen_external_scanner_create,
      tree_sitter_tablegen_external_scanner_destroy,
      tree_sitter_tablegen_external_scanner_scan,
      tree_sitter_tablegen_external_scanner_serialize,
      tree_sitter_tablegen_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
